import { ɵɵelementStart, ɵɵtext, ɵɵpipe, ɵɵelementEnd, ɵɵnextContext, ɵɵadvance, ɵɵtextInterpolate, ɵɵpipeBind1, ɵɵproperty, ɵɵtemplate, ɵɵelement, ɵɵtextInterpolate1, ɵɵelementContainerStart, ɵɵelementContainerEnd, ɵɵgetCurrentView, ɵɵlistener, ɵɵrestoreView, EventEmitter, isDevMode, ɵɵdefineComponent, ɵɵstaticViewQuery, ɵɵqueryRefresh, ɵɵloadQuery, ɵɵpureFunction0, ɵsetClassMetadata, Component, ViewEncapsulation, Input, Output, ViewChild, ɵɵpureFunction3, ɵɵdirectiveInject, forwardRef, ɵɵprojectionDef, ɵɵprojection, Inject, ɵɵtextInterpolate2, ɵɵpropertyInterpolate, ɵɵdefineNgModule, ɵɵdefineInjector, ɵɵsetNgModuleScope, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { MatSort, MatSortHeader, MatSortModule } from '@angular/material/sort';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import { AccountUtilities, PartnerType } from '@yukawa/chain-crm-angular-core';
import { ProjectPhase, ProjectSheetService, RiskService, Fep, AttachmentService } from '@yukawa/chain-tracker-angular-core';
import { MatTable, MatColumnDef, MatHeaderCellDef, MatCellDef, MatHeaderRowDef, MatRowDef, MatHeaderCell, MatCell, MatHeaderRow, MatRow, MatTableModule } from '@angular/material/table';
import { NgForOf, NgIf, NgClass, DatePipe, CommonModule } from '@angular/common';
import { MatTooltip, MatTooltipModule } from '@angular/material/tooltip';
import { DefaultLayoutAlignDirective, DefaultFlexDirective, DefaultLayoutDirective } from '@angular/flex-layout/flex';
import { CdkColumnDef, CdkHeaderCellDef, CdkCellDef, CdkTableModule } from '@angular/cdk/table';
import { TranslatePipe, TranslateModule } from '@ngx-translate/core';
import { QueryTableSource } from '@yukawa/chain-base-angular-store';
import { BehaviorSubject, fromEvent } from 'rxjs';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';
import { ActivatedRoute } from '@angular/router';
import { MatIcon, MatIconModule } from '@angular/material/icon';
import { DefaultClassDirective } from '@angular/flex-layout/extended';
import { MatButton, MatButtonModule } from '@angular/material/button';
import { ɵangular_packages_forms_forms_y, NgControlStatusGroup, FormGroupDirective, DefaultValueAccessor, NgControlStatus, FormControlName, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { MatLabel } from '@angular/material/form-field';
import { MatSelect, MatSelectModule } from '@angular/material/select';
import { MatOption, MatRippleModule } from '@angular/material/core';
import { FlexLayoutModule } from '@angular/flex-layout';
import { HttpClientModule } from '@angular/common/http';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatMenuModule } from '@angular/material/menu';
import { MatCheckboxModule } from '@angular/material/checkbox';

function ProjectTableComponent_mat_header_cell_6_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = ɵɵnextContext();
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, ctx_r2.getIdHeader()));
} }
function ProjectTableComponent_mat_cell_7_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span", 25);
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r33 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("matTooltip", row_r33.phase);
    ɵɵadvance(1);
    ɵɵtextInterpolate((row_r33.info == null ? null : row_r33.info.shortName) || row_r33.projectId);
} }
function ProjectTableComponent_mat_header_cell_9_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.ID"));
} }
function ProjectTableComponent_mat_cell_10_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span", 25);
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("matTooltip", row_r34.phase);
    ɵɵadvance(1);
    ɵɵtextInterpolate((row_r34.info == null ? null : row_r34.info.shortName) || row_r34.projectId);
} }
function ProjectTableComponent_mat_header_cell_12_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.NAME"));
} }
function ProjectTableComponent_mat_cell_13_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span", 25);
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r35 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("matTooltip", row_r35.info == null ? null : row_r35.info.desc);
    ɵɵadvance(1);
    ɵɵtextInterpolate(row_r35.info == null ? null : row_r35.info.name);
} }
function ProjectTableComponent_mat_header_cell_15_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.CUSTOMER"));
} }
function ProjectTableComponent_mat_cell_16_div_1_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "div", 27);
    ɵɵelementStart(1, "span", 28);
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r36 = ɵɵnextContext().$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r36 == null ? null : row_r36.customer == null ? null : row_r36.customer.companyName);
} }
function ProjectTableComponent_mat_cell_16_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtemplate(1, ProjectTableComponent_mat_cell_16_div_1_Template, 3, 1, "div", 26);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r36 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("ngIf", row_r36.customer);
} }
function ProjectTableComponent_mat_header_cell_18_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.OWNER"));
} }
function ProjectTableComponent_mat_cell_19_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r40 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r40 == null ? null : row_r40.change == null ? null : row_r40.change.user);
} }
function ProjectTableComponent_mat_header_cell_21_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.HEAD_ENGINEER"));
} }
function ProjectTableComponent_mat_cell_22_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r41 = ctx.$implicit;
    const ctx_r13 = ɵɵnextContext();
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r41.head != null ? ctx_r13.accountUtils.getDisplayName(row_r41.head, ctx_r13.partnerType.PERSON) : "");
} }
function ProjectTableComponent_mat_header_cell_24_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.START_DATE"));
} }
function ProjectTableComponent_mat_cell_25_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelement(1, "base-date", 29);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r42 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("data", row_r42.actualStartDate);
} }
function ProjectTableComponent_mat_header_cell_27_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.END_DATE"));
} }
function ProjectTableComponent_mat_cell_28_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelement(1, "base-date", 29);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r43 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("data", row_r43.actualEndDate);
} }
function ProjectTableComponent_mat_header_cell_30_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.START_DATE"));
} }
function ProjectTableComponent_mat_cell_31_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelement(1, "base-date", 29);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r44 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("data", row_r44.plannedStartDate);
} }
function ProjectTableComponent_mat_header_cell_33_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.END_DATE"));
} }
function ProjectTableComponent_mat_cell_34_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelement(1, "base-date", 29);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r45 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("data", row_r45.plannedEndDate);
} }
function ProjectTableComponent_mat_header_cell_36_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "COMMON.CHANGE_DATE"));
} }
function ProjectTableComponent_mat_cell_37_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelement(1, "base-date", 30);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r46 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("data", row_r46.change == null ? null : row_r46.change.date)("matTooltip", row_r46.change == null ? null : row_r46.change.user);
} }
function ProjectTableComponent_mat_header_cell_39_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.PHASE"));
} }
function ProjectTableComponent_mat_cell_40_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r47 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r47 == null ? null : row_r47.phase);
} }
function ProjectTableComponent_mat_header_cell_42_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.STATUS"));
} }
function ProjectTableComponent_mat_cell_43_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r48 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate1(" ", row_r48.status, " ");
} }
function ProjectTableComponent_mat_header_cell_45_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 24);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.HEADER.ESTIMATED_VOLUME"));
} }
function ProjectTableComponent_mat_cell_46_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r49 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate((row_r49 == null ? null : row_r49.plannedBudget == null ? null : row_r49.plannedBudget.money) !== null ? row_r49.plannedBudget.money + " \u20AC" : "");
} }
function ProjectTableComponent_ng_container_47_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const column_r50 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate(column_r50.header);
} }
function ProjectTableComponent_ng_container_47_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r54 = ctx.$implicit;
    const column_r50 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate(column_r50.cell(row_r54));
} }
function ProjectTableComponent_ng_container_47_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementContainerStart(0, 31);
    ɵɵtemplate(1, ProjectTableComponent_ng_container_47_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 32);
    ɵɵtemplate(2, ProjectTableComponent_ng_container_47_mat_cell_2_Template, 2, 1, "mat-cell", 33);
    ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r50 = ctx.$implicit;
    ɵɵproperty("cdkColumnDef", column_r50.columnDef);
} }
function ProjectTableComponent_mat_header_row_48_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "mat-header-row");
} }
function ProjectTableComponent_mat_row_49_Template(rf, ctx) { if (rf & 1) {
    const _r58 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "mat-row", 34);
    ɵɵlistener("click", function ProjectTableComponent_mat_row_49_Template_mat_row_click_0_listener() { ɵɵrestoreView(_r58); const row_r56 = ctx.$implicit; const ctx_r57 = ɵɵnextContext(); return ctx_r57.onAction("edit", row_r56); });
    ɵɵelementEnd();
} }
const _c0 = function () { return [5, 10, 25, 100]; };
const TAG = 'ProjectTableComponent';
class ProjectTableComponent {
    constructor() {
        this.displayedColumns = ['projectId', 'phase', 'info.name', 'customer.companyName', 'created.user', 'head', 'actualStartDate', 'actualEndDate', 'plannedBudget.money'];
        this.customColumns = [];
        this.action = new EventEmitter();
        this.accountUtils = AccountUtilities;
        this.partnerType = PartnerType;
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let abc = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...abc);
        }
        else {
        }
    }
    /**
     * On destroy
     */
    ngOnDestroy() {
        this.action.complete();
    }
    onAction(type = "", project) {
        if (isDevMode()) {
            console.debug(TAG, "onAction", project);
        }
        event.stopPropagation();
        this.fireAction({ type: type, project: project });
    }
    fireAction(action) {
        this.action.emit(action);
    }
    onOverlayAction(action) {
        if (action === 'close') {
            this.partnerDetailsRowId = "";
        }
    }
    getIdHeader() {
        // return  this.onAction("getIdHeader",null)
        return ProjectPhase.PHASE_LEAD;
        // let phase = this._route.snapshot.params.phase
        // switch (phase) {
        //     case ProjectPhase.PHASE_LEAD:
        //         return "PROJECT.HEADER.LEAD_ID"
        //     case ProjectPhase.PHASE_PROJECT:
        //         return "PROJECT.HEADER.PROJECT_ID"
        //     case ProjectPhase.PHASE_PROPOSAL:
        //         return "PROJECT.HEADER.OPPORTUNITY_ID";
        //     default:
        //         return "PROJECT.HEADER.ID";
        // }
    }
}
/** @nocollapse */ ProjectTableComponent.ɵfac = function ProjectTableComponent_Factory(t) { return new (t || ProjectTableComponent)(); };
/** @nocollapse */ ProjectTableComponent.ɵcmp = ɵɵdefineComponent({ type: ProjectTableComponent, selectors: [["chain-tracker-project-table"]], viewQuery: function ProjectTableComponent_Query(rf, ctx) { if (rf & 1) {
        ɵɵstaticViewQuery(MatPaginator, true);
        ɵɵstaticViewQuery(MatSort, true);
    } if (rf & 2) {
        let _t;
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.paginator = _t.first);
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.sort = _t.first);
    } }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", dataSource: "dataSource" }, outputs: { action: "action" }, decls: 50, vars: 8, consts: [[1, "table-layout-1"], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortActive", "actualStartDate", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "projectId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "info.shortName"], ["matColumnDef", "info.name", 1, "mat-column-info-name"], ["matColumnDef", "customer.companyName"], ["matColumnDef", "created.user", 1, "mat-column-owner"], ["matColumnDef", "head"], ["matColumnDef", "actualStartDate"], ["matColumnDef", "actualEndDate"], ["matColumnDef", "plannedStartDate"], ["matColumnDef", "plannedEndDate"], ["matColumnDef", "changed.date"], ["matColumnDef", "phase"], ["matColumnDef", "status"], ["matColumnDef", "plannedBudget.money"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [3, "matTooltip"], ["fxLayoutAlign", "none center", 4, "ngIf"], ["fxLayoutAlign", "none center"], ["fxFlex", "90", 1, "customer-name"], ["format", "day", "formatTip", "false", 3, "data"], ["format", "date", "formatTip", "false", 3, "data", "matTooltip"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], [3, "click"]], template: function ProjectTableComponent_Template(rf, ctx) { if (rf & 1) {
        ɵɵelementStart(0, "div", 0);
        ɵɵelement(1, "mat-paginator", 1, 2);
        ɵɵelementStart(3, "mat-table", 3, 4);
        ɵɵelementContainerStart(5, 5);
        ɵɵtemplate(6, ProjectTableComponent_mat_header_cell_6_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(7, ProjectTableComponent_mat_cell_7_Template, 3, 2, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(8, 8);
        ɵɵtemplate(9, ProjectTableComponent_mat_header_cell_9_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(10, ProjectTableComponent_mat_cell_10_Template, 3, 2, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(11, 9);
        ɵɵtemplate(12, ProjectTableComponent_mat_header_cell_12_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(13, ProjectTableComponent_mat_cell_13_Template, 3, 2, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(14, 10);
        ɵɵtemplate(15, ProjectTableComponent_mat_header_cell_15_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(16, ProjectTableComponent_mat_cell_16_Template, 2, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(17, 11);
        ɵɵtemplate(18, ProjectTableComponent_mat_header_cell_18_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(19, ProjectTableComponent_mat_cell_19_Template, 3, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(20, 12);
        ɵɵtemplate(21, ProjectTableComponent_mat_header_cell_21_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(22, ProjectTableComponent_mat_cell_22_Template, 3, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(23, 13);
        ɵɵtemplate(24, ProjectTableComponent_mat_header_cell_24_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(25, ProjectTableComponent_mat_cell_25_Template, 2, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(26, 14);
        ɵɵtemplate(27, ProjectTableComponent_mat_header_cell_27_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(28, ProjectTableComponent_mat_cell_28_Template, 2, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(29, 15);
        ɵɵtemplate(30, ProjectTableComponent_mat_header_cell_30_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(31, ProjectTableComponent_mat_cell_31_Template, 2, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(32, 16);
        ɵɵtemplate(33, ProjectTableComponent_mat_header_cell_33_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(34, ProjectTableComponent_mat_cell_34_Template, 2, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(35, 17);
        ɵɵtemplate(36, ProjectTableComponent_mat_header_cell_36_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(37, ProjectTableComponent_mat_cell_37_Template, 2, 2, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(38, 18);
        ɵɵtemplate(39, ProjectTableComponent_mat_header_cell_39_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(40, ProjectTableComponent_mat_cell_40_Template, 3, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(41, 19);
        ɵɵtemplate(42, ProjectTableComponent_mat_header_cell_42_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(43, ProjectTableComponent_mat_cell_43_Template, 2, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(44, 20);
        ɵɵtemplate(45, ProjectTableComponent_mat_header_cell_45_Template, 3, 3, "mat-header-cell", 6);
        ɵɵtemplate(46, ProjectTableComponent_mat_cell_46_Template, 3, 1, "mat-cell", 7);
        ɵɵelementContainerEnd();
        ɵɵtemplate(47, ProjectTableComponent_ng_container_47_Template, 3, 1, "ng-container", 21);
        ɵɵtemplate(48, ProjectTableComponent_mat_header_row_48_Template, 1, 0, "mat-header-row", 22);
        ɵɵtemplate(49, ProjectTableComponent_mat_row_49_Template, 1, 0, "mat-row", 23);
        ɵɵelementEnd();
        ɵɵelementEnd();
    } if (rf & 2) {
        ɵɵadvance(1);
        ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", ɵɵpureFunction0(7, _c0));
        ɵɵadvance(2);
        ɵɵproperty("dataSource", ctx.dataSource);
        ɵɵadvance(44);
        ɵɵproperty("ngForOf", ctx.customColumns);
        ɵɵadvance(1);
        ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
        ɵɵadvance(1);
        ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
    } }, directives: [MatPaginator, MatTable, MatSort, MatColumnDef, MatHeaderCellDef, MatCellDef, NgForOf, MatHeaderRowDef, MatRowDef, MatHeaderCell, MatSortHeader, MatCell, MatTooltip, NgIf, DefaultLayoutAlignDirective, DefaultFlexDirective, CdkColumnDef, CdkHeaderCellDef, CdkCellDef, MatHeaderRow, MatRow], pipes: [TranslatePipe], styles: ["chain-tracker-project-table{width:100%!important}chain-tracker-project-table .mat-table{background:transparent;box-shadow:none}chain-tracker-project-table .mat-table .mat-row{cursor:pointer!important;min-height:64px;position:relative}chain-tracker-project-table .info-icon{padding-right:5px}chain-tracker-project-table .customer-name{margin-right:20px!important}chain-tracker-project-table .mat-column-customer{flex:0 0 18%!important;white-space:unset!important;width:18%!important}chain-tracker-project-table .mat-column-customer,chain-tracker-project-table .mat-column-info-name{-ms-hyphens:auto;-webkit-hyphens:auto;hyphens:auto;overflow-wrap:break-word;word-break:break-word;word-wrap:break-word}chain-tracker-project-table .mat-column-info-name{flex:0 0 15%!important;white-space:nowrap!important;width:15%!important}chain-tracker-project-table .mat-column-created-user{-ms-hyphens:auto;-webkit-hyphens:auto;flex:0 0 12%!important;hyphens:auto;overflow-wrap:break-word;white-space:unset!important;width:12%!important;word-break:break-word;word-wrap:break-word}chain-tracker-project-table .mat-column-headEngineer,chain-tracker-project-table .mat-column-plannedBudget-money{-ms-hyphens:auto;-webkit-hyphens:auto;hyphens:auto;white-space:pre-wrap}chain-tracker-project-table .mat-column-headEngineer{text-align:center}"], encapsulation: 2 });
/*@__PURE__*/ (function () { ɵsetClassMetadata(ProjectTableComponent, [{
        type: Component,
        args: [{
                selector: 'chain-tracker-project-table',
                templateUrl: './project-table.component.html',
                styleUrls: ['./project-table.component.scss'],
                encapsulation: ViewEncapsulation.None
            }]
    }], function () { return []; }, { displayedColumns: [{
            type: Input
        }], customColumns: [{
            type: Input
        }], dataSource: [{
            type: Input
        }], action: [{
            type: Output
        }], paginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }], sort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }] }); })();

class ProjectQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        //this.applyPaginator(filter, this.paginator)
        if (filter.keyword)
            filter.keyword += '*';
        /*    if (filter.orderBy)
              filter.orderBy += '.keyword'*/
        return this.service.queryProject(filter);
    }
}

class ProjectSheetQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.queryProjectSheet(filter);
    }
}

const _c0$1 = ["projectsheetfilter"];
function ProjectSheetTableComponent_mat_header_cell_17_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 25);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate1("", ɵɵpipeBind1(2, 1, "PROJECT_SHEET.REPORT_DATE"), " ");
} }
function ProjectSheetTableComponent_mat_cell_18_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵpipe(3, "date");
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r18 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(ɵɵpipeBind1(3, 1, row_r18.reportDate));
} }
function ProjectSheetTableComponent_mat_header_cell_20_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 25);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT_SHEET.NAME"));
} }
function ProjectSheetTableComponent_mat_cell_21_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r19 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r19 == null ? null : row_r19.info == null ? null : row_r19.info.name);
} }
function ProjectSheetTableComponent_mat_header_cell_23_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 25);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT_SHEET.STATUS"));
} }
const _c1 = function (a0, a1, a2) { return { "dot-red": a0, "dot-green": a1, "dot-yellow": a2 }; };
function ProjectSheetTableComponent_mat_cell_24_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelement(1, "span", 26);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r20 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("ngClass", ɵɵpureFunction3(1, _c1, row_r20.status == "red", row_r20.status == "green", row_r20.status == "yellow"));
} }
function ProjectSheetTableComponent_mat_header_cell_26_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 25);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT_SHEET.PERCENTAGE"));
} }
function ProjectSheetTableComponent_mat_cell_27_span_1_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "span");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r21 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate1("", row_r21 == null ? null : row_r21.percentageOfCompletion, " %");
} }
function ProjectSheetTableComponent_mat_cell_27_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtemplate(1, ProjectSheetTableComponent_mat_cell_27_span_1_Template, 2, 1, "span", 27);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r21 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("ngIf", row_r21.percentageOfCompletion);
} }
function ProjectSheetTableComponent_mat_header_cell_29_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 25);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT_SHEET.AMOUNT"));
} }
function ProjectSheetTableComponent_mat_cell_30_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r24 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r24 == null ? null : row_r24.budget == null ? null : row_r24.budget.amount);
} }
function ProjectSheetTableComponent_ng_container_31_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const column_r25 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate(column_r25.header);
} }
function ProjectSheetTableComponent_ng_container_31_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r29 = ctx.$implicit;
    const column_r25 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate(column_r25.cell(row_r29));
} }
function ProjectSheetTableComponent_ng_container_31_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementContainerStart(0, 28);
    ɵɵtemplate(1, ProjectSheetTableComponent_ng_container_31_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 29);
    ɵɵtemplate(2, ProjectSheetTableComponent_ng_container_31_mat_cell_2_Template, 2, 1, "mat-cell", 30);
    ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r25 = ctx.$implicit;
    ɵɵproperty("cdkColumnDef", column_r25.columnDef);
} }
function ProjectSheetTableComponent_mat_header_cell_33_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "mat-header-cell");
} }
function ProjectSheetTableComponent_mat_cell_34_Template(rf, ctx) { if (rf & 1) {
    const _r33 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "button", 31);
    ɵɵlistener("click", function ProjectSheetTableComponent_mat_cell_34_Template_button_click_1_listener() { ɵɵrestoreView(_r33); const row_r31 = ctx.$implicit; const ctx_r32 = ɵɵnextContext(); return ctx_r32.onAction("delete", row_r31); });
    ɵɵelementStart(2, "mat-icon", 32);
    ɵɵtext(3, " delete ");
    ɵɵelementEnd();
    ɵɵelementEnd();
    ɵɵelementEnd();
} }
function ProjectSheetTableComponent_mat_header_row_35_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "mat-header-row");
} }
function ProjectSheetTableComponent_mat_row_36_Template(rf, ctx) { if (rf & 1) {
    const _r36 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "mat-row", 33);
    ɵɵlistener("click", function ProjectSheetTableComponent_mat_row_36_Template_mat_row_click_0_listener() { ɵɵrestoreView(_r36); const row_r34 = ctx.$implicit; const ctx_r35 = ɵɵnextContext(); return ctx_r35.onAction("edit", row_r34); });
    ɵɵelementEnd();
} }
const _c2 = function () { return [5, 10, 25, 100]; };
const _c3 = ["*"];
const TAG$1 = "ProjectSheetTableComponent";
class ProjectSheetTableComponent {
    constructor(service, _route) {
        this.service = service;
        this._route = _route;
        // routeAnimationsElements = ROUTE_ANIMATIONS_ELEMENTS;
        this.displayedColumns = ['reportDate', 'status', 'percentageOfCompletion', 'budget.amount'];
        this.customColumns = [];
        this.projectSheetFilter = { type: null, projectId: null };
        this.action = new EventEmitter();
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let abc = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...abc);
            this.displayedColumns.push("action");
        }
        else {
            this.displayedColumns.push("action");
        }
        this._route.params.pipe().subscribe((params) => {
            this.projectSheetFilter.projectId = params.projectId;
            this.dataSource = new ProjectSheetQueryStore(this.service, this.paginator, this.sort, this.projectSheetFilter);
            fromEvent(this.filter.nativeElement, 'keyup')
                .pipe(debounceTime(1000), distinctUntilChanged())
                .subscribe(event => {
                let value = this.filter.nativeElement.value;
                if (value == '')
                    value = null;
                let filter = this.dataSource.filterSubject.value;
                filter.keyword = value;
                this.applyFilter(filter);
            });
        });
    }
    ngOnDestroy() {
        this.action.complete();
    }
    reload(keyword = null) {
        if (keyword)
            this.projectSheetFilter.keyword = keyword;
        this.applyFilter(this.projectSheetFilter);
    }
    applyFilter(filter) {
        this.dataSource.filterSubject.next(filter);
    }
    onAction(type = "", projectSheet) {
        if (isDevMode()) {
            console.debug(TAG$1, "onAction", projectSheet);
        }
        event.stopPropagation();
        this.fireAction({ type: type, projectSheet: projectSheet });
    }
    fireAction(action) {
        this.action.emit(action);
    }
}
/** @nocollapse */ ProjectSheetTableComponent.ɵfac = function ProjectSheetTableComponent_Factory(t) { return new (t || ProjectSheetTableComponent)(ɵɵdirectiveInject(forwardRef(() => ProjectSheetService)), ɵɵdirectiveInject(forwardRef(() => ActivatedRoute))); };
/** @nocollapse */ ProjectSheetTableComponent.ɵcmp = ɵɵdefineComponent({ type: ProjectSheetTableComponent, selectors: [["chain-project-sheet-table"]], viewQuery: function ProjectSheetTableComponent_Query(rf, ctx) { if (rf & 1) {
        ɵɵstaticViewQuery(MatPaginator, true);
        ɵɵstaticViewQuery(MatSort, true);
        ɵɵstaticViewQuery(_c0$1, true);
    } if (rf & 2) {
        let _t;
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.paginator = _t.first);
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.sort = _t.first);
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.filter = _t.first);
    } }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", projectSheetFilter: "projectSheetFilter" }, outputs: { action: "action" }, ngContentSelectors: _c3, decls: 37, vars: 8, consts: [["fxLayout", "row", "fxLayoutAlign", "space-between center", 1, ""], ["fxLayout", "row", "fxLayoutAlign", "space-between center", "fxFlex", ""], [1, "field-wrap"], [1, "field-box", "trans-icon"], ["type", "text"], ["projectsheetfilter", ""], ["type", "submit"], [1, ""], ["fxFlex", "30", 3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], [1, "table-layout-1"], ["matSort", "", "matSortActive", "reportDate", "matSortDirection", "desc", "matSortDisableClear", "", 3, "dataSource"], ["table", ""], ["matColumnDef", "reportDate"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "info.name"], ["matColumnDef", "status"], ["matColumnDef", "percentageOfCompletion"], ["matColumnDef", "budget.amount"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "action"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [1, "dot", 3, "ngClass"], [4, "ngIf"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-button", "", 3, "click"], ["color", "warn"], [3, "click"]], template: function ProjectSheetTableComponent_Template(rf, ctx) { if (rf & 1) {
        ɵɵprojectionDef();
        ɵɵelementStart(0, "mat-toolbar", 0);
        ɵɵelementStart(1, "div", 1);
        ɵɵprojection(2);
        ɵɵelementStart(3, "div", 2);
        ɵɵelementStart(4, "div", 3);
        ɵɵelement(5, "input", 4, 5);
        ɵɵelementStart(7, "button", 6);
        ɵɵelementStart(8, "i", 7);
        ɵɵelementStart(9, "mat-icon");
        ɵɵtext(10, " search ");
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelement(11, "mat-paginator", 8, 9);
        ɵɵelementEnd();
        ɵɵelementStart(13, "div", 10);
        ɵɵelementStart(14, "mat-table", 11, 12);
        ɵɵelementContainerStart(16, 13);
        ɵɵtemplate(17, ProjectSheetTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 14);
        ɵɵtemplate(18, ProjectSheetTableComponent_mat_cell_18_Template, 4, 3, "mat-cell", 15);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(19, 16);
        ɵɵtemplate(20, ProjectSheetTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 14);
        ɵɵtemplate(21, ProjectSheetTableComponent_mat_cell_21_Template, 3, 1, "mat-cell", 15);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(22, 17);
        ɵɵtemplate(23, ProjectSheetTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 14);
        ɵɵtemplate(24, ProjectSheetTableComponent_mat_cell_24_Template, 2, 5, "mat-cell", 15);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(25, 18);
        ɵɵtemplate(26, ProjectSheetTableComponent_mat_header_cell_26_Template, 3, 3, "mat-header-cell", 14);
        ɵɵtemplate(27, ProjectSheetTableComponent_mat_cell_27_Template, 2, 1, "mat-cell", 15);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(28, 19);
        ɵɵtemplate(29, ProjectSheetTableComponent_mat_header_cell_29_Template, 3, 3, "mat-header-cell", 14);
        ɵɵtemplate(30, ProjectSheetTableComponent_mat_cell_30_Template, 3, 1, "mat-cell", 15);
        ɵɵelementContainerEnd();
        ɵɵtemplate(31, ProjectSheetTableComponent_ng_container_31_Template, 3, 1, "ng-container", 20);
        ɵɵelementContainerStart(32, 21);
        ɵɵtemplate(33, ProjectSheetTableComponent_mat_header_cell_33_Template, 1, 0, "mat-header-cell", 22);
        ɵɵtemplate(34, ProjectSheetTableComponent_mat_cell_34_Template, 4, 0, "mat-cell", 15);
        ɵɵelementContainerEnd();
        ɵɵtemplate(35, ProjectSheetTableComponent_mat_header_row_35_Template, 1, 0, "mat-header-row", 23);
        ɵɵtemplate(36, ProjectSheetTableComponent_mat_row_36_Template, 1, 0, "mat-row", 24);
        ɵɵelementEnd();
        ɵɵelementEnd();
    } if (rf & 2) {
        ɵɵadvance(11);
        ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", ɵɵpureFunction0(7, _c2));
        ɵɵadvance(3);
        ɵɵproperty("dataSource", ctx.dataSource);
        ɵɵadvance(17);
        ɵɵproperty("ngForOf", ctx.customColumns);
        ɵɵadvance(4);
        ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
        ɵɵadvance(1);
        ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
    } }, directives: [DefaultLayoutDirective, DefaultLayoutAlignDirective, DefaultFlexDirective, MatIcon, MatPaginator, MatTable, MatSort, MatColumnDef, MatHeaderCellDef, MatCellDef, NgForOf, MatHeaderRowDef, MatRowDef, MatHeaderCell, MatSortHeader, MatCell, NgClass, DefaultClassDirective, NgIf, CdkColumnDef, CdkHeaderCellDef, CdkCellDef, MatButton, MatHeaderRow, MatRow], pipes: [TranslatePipe, DatePipe], styles: ["chain-project-sheet-table{width:100%}chain-project-sheet-table .mat-table{background:transparent;box-shadow:none}chain-project-sheet-table .mat-table .mat-row{cursor:pointer;min-height:64px;position:relative}.dot{border-radius:50%;display:inline-block;height:20px!important;margin-left:40px;width:20px!important}.dot-red{background-color:red}.dot-green{background-color:green}.dot-yellow{background-color:#ff0}"], encapsulation: 2 });
/*@__PURE__*/ (function () { ɵsetClassMetadata(ProjectSheetTableComponent, [{
        type: Component,
        args: [{
                selector: 'chain-project-sheet-table',
                templateUrl: './project-sheet-table.component.html',
                styleUrls: ['./project-sheet-table.component.scss'],
                encapsulation: ViewEncapsulation.None
            }]
    }], function () { return [{ type: ProjectSheetService, decorators: [{
                type: Inject,
                args: [forwardRef(() => ProjectSheetService)]
            }] }, { type: ActivatedRoute, decorators: [{
                type: Inject,
                args: [forwardRef(() => ActivatedRoute)]
            }] }]; }, { displayedColumns: [{
            type: Input
        }], customColumns: [{
            type: Input
        }], projectSheetFilter: [{
            type: Input
        }], action: [{
            type: Output
        }], paginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }], sort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }], filter: [{
            type: ViewChild,
            args: ['projectsheetfilter', { static: true }]
        }] }); })();

class RisksTableQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.queryRisks(filter);
    }
}

function RisksTableComponent_mat_header_cell_8_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 19);
    ɵɵtext(1, "Risk Id");
    ɵɵelementEnd();
} }
function RisksTableComponent_mat_cell_9_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r19 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r19 == null ? null : row_r19.riskId);
} }
function RisksTableComponent_mat_header_cell_11_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 19);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT_SHEET.RISK.NAME"));
} }
function RisksTableComponent_mat_cell_12_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r20 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r20 == null ? null : row_r20.name);
} }
function RisksTableComponent_mat_header_cell_14_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 19);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT_SHEET.MITIGATION"));
} }
function RisksTableComponent_mat_cell_15_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r21 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r21 == null ? null : row_r21.mitigation);
} }
function RisksTableComponent_mat_header_cell_17_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 19);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.RISKS.SEVERITY"));
} }
function RisksTableComponent_mat_cell_18_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r22 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r22 == null ? null : row_r22.severity);
} }
function RisksTableComponent_mat_header_cell_20_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 19);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT_SHEET.PROBABILITY"));
} }
function RisksTableComponent_mat_cell_21_span_1_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "span");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r23 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate((row_r23 == null ? null : row_r23.probability) + "%");
} }
function RisksTableComponent_mat_cell_21_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtemplate(1, RisksTableComponent_mat_cell_21_span_1_Template, 2, 1, "span", 20);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r23 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("ngIf", row_r23.probability);
} }
function RisksTableComponent_mat_header_cell_23_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 19);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "PROJECT.RISKS.STATUS"));
} }
function RisksTableComponent_mat_cell_24_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r26 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r26 == null ? null : row_r26.status);
} }
function RisksTableComponent_ng_container_25_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const column_r27 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate(column_r27.header);
} }
function RisksTableComponent_ng_container_25_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r31 = ctx.$implicit;
    const column_r27 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate(column_r27.cell(row_r31));
} }
function RisksTableComponent_ng_container_25_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementContainerStart(0, 21);
    ɵɵtemplate(1, RisksTableComponent_ng_container_25_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 22);
    ɵɵtemplate(2, RisksTableComponent_ng_container_25_mat_cell_2_Template, 2, 1, "mat-cell", 23);
    ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r27 = ctx.$implicit;
    ɵɵproperty("cdkColumnDef", column_r27.columnDef);
} }
function RisksTableComponent_mat_header_cell_27_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "mat-header-cell");
} }
function RisksTableComponent_mat_cell_28_Template(rf, ctx) { if (rf & 1) {
    const _r35 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "button", 24);
    ɵɵlistener("click", function RisksTableComponent_mat_cell_28_Template_button_click_1_listener($event) { ɵɵrestoreView(_r35); const row_r33 = ctx.$implicit; const ctx_r34 = ɵɵnextContext(); ctx_r34.deleteRisk(row_r33.riskId); return $event.stopPropagation(); });
    ɵɵelementStart(2, "mat-icon", 25);
    ɵɵtext(3, " delete ");
    ɵɵelementEnd();
    ɵɵelementEnd();
    ɵɵelementEnd();
} }
function RisksTableComponent_mat_header_row_29_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "mat-header-row");
} }
function RisksTableComponent_mat_row_30_Template(rf, ctx) { if (rf & 1) {
    const _r38 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "mat-row", 26);
    ɵɵlistener("click", function RisksTableComponent_mat_row_30_Template_mat_row_click_0_listener() { ɵɵrestoreView(_r38); const row_r36 = ctx.$implicit; const ctx_r37 = ɵɵnextContext(); return ctx_r37.onAction("edit", row_r36); });
    ɵɵelementEnd();
} }
const _c0$2 = function () { return [5, 10, 25, 100]; };
const _c1$1 = ["*"];
class RisksTableComponent {
    constructor(_riskService) {
        this._riskService = _riskService;
        this.displayedColumns = ['name', 'mitigation', 'severity', 'probability', 'status'];
        this.customColumns = [];
        this.action = new EventEmitter();
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let abc = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...abc);
            this.displayedColumns.push("actions");
        }
        else {
            this.displayedColumns.push("actions");
        }
        let filter = {};
        //TODO change this when RisksFilter is exposd GK
        filter['projectId'] = this.projectId;
        if (!this.dataSource) {
            this.dataSource = new RisksTableQueryStore(this._riskService, this.paginator, this.sort, filter);
        }
    }
    onAction(type, payload) {
        this.action.emit({ type: type, value: payload });
    }
    deleteRisk(event) {
        this.onAction('delete', { riskId: event });
    }
}
/** @nocollapse */ RisksTableComponent.ɵfac = function RisksTableComponent_Factory(t) { return new (t || RisksTableComponent)(ɵɵdirectiveInject(forwardRef(() => RiskService))); };
/** @nocollapse */ RisksTableComponent.ɵcmp = ɵɵdefineComponent({ type: RisksTableComponent, selectors: [["chain-app-risks-table"]], viewQuery: function RisksTableComponent_Query(rf, ctx) { if (rf & 1) {
        ɵɵstaticViewQuery(MatPaginator, true);
        ɵɵstaticViewQuery(MatSort, true);
    } if (rf & 2) {
        let _t;
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.paginator = _t.first);
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.sort = _t.first);
    } }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", projectId: "projectId", dataSource: "dataSource" }, outputs: { action: "action" }, ngContentSelectors: _c1$1, decls: 31, vars: 8, consts: [[1, "table-layout-1"], ["fxLayoutAlign", "space-between center", 1, ""], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "riskId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "name"], ["matColumnDef", "mitigation"], ["matColumnDef", "severity"], ["matColumnDef", "probability"], ["matColumnDef", "status"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "actions"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [4, "ngIf"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-button", "", 3, "click"], ["color", "warn", 1, ""], [3, "click"]], template: function RisksTableComponent_Template(rf, ctx) { if (rf & 1) {
        ɵɵprojectionDef();
        ɵɵelementStart(0, "div", 0);
        ɵɵelementStart(1, "mat-toolbar", 1);
        ɵɵprojection(2);
        ɵɵelement(3, "mat-paginator", 2, 3);
        ɵɵelementEnd();
        ɵɵelementStart(5, "mat-table", 4, 5);
        ɵɵelementContainerStart(7, 6);
        ɵɵtemplate(8, RisksTableComponent_mat_header_cell_8_Template, 2, 0, "mat-header-cell", 7);
        ɵɵtemplate(9, RisksTableComponent_mat_cell_9_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(10, 9);
        ɵɵtemplate(11, RisksTableComponent_mat_header_cell_11_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(12, RisksTableComponent_mat_cell_12_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(13, 10);
        ɵɵtemplate(14, RisksTableComponent_mat_header_cell_14_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(15, RisksTableComponent_mat_cell_15_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(16, 11);
        ɵɵtemplate(17, RisksTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(18, RisksTableComponent_mat_cell_18_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(19, 12);
        ɵɵtemplate(20, RisksTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(21, RisksTableComponent_mat_cell_21_Template, 2, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(22, 13);
        ɵɵtemplate(23, RisksTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(24, RisksTableComponent_mat_cell_24_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵtemplate(25, RisksTableComponent_ng_container_25_Template, 3, 1, "ng-container", 14);
        ɵɵelementContainerStart(26, 15);
        ɵɵtemplate(27, RisksTableComponent_mat_header_cell_27_Template, 1, 0, "mat-header-cell", 16);
        ɵɵtemplate(28, RisksTableComponent_mat_cell_28_Template, 4, 0, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵtemplate(29, RisksTableComponent_mat_header_row_29_Template, 1, 0, "mat-header-row", 17);
        ɵɵtemplate(30, RisksTableComponent_mat_row_30_Template, 1, 0, "mat-row", 18);
        ɵɵelementEnd();
        ɵɵelementEnd();
    } if (rf & 2) {
        ɵɵadvance(3);
        ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", ɵɵpureFunction0(7, _c0$2));
        ɵɵadvance(2);
        ɵɵproperty("dataSource", ctx.dataSource);
        ɵɵadvance(20);
        ɵɵproperty("ngForOf", ctx.customColumns);
        ɵɵadvance(4);
        ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
        ɵɵadvance(1);
        ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
    } }, directives: [DefaultLayoutAlignDirective, MatPaginator, MatTable, MatSort, MatColumnDef, MatHeaderCellDef, MatCellDef, NgForOf, MatHeaderRowDef, MatRowDef, MatHeaderCell, MatSortHeader, MatCell, NgIf, CdkColumnDef, CdkHeaderCellDef, CdkCellDef, MatButton, MatIcon, MatHeaderRow, MatRow], pipes: [TranslatePipe], styles: [""] });
/*@__PURE__*/ (function () { ɵsetClassMetadata(RisksTableComponent, [{
        type: Component,
        args: [{
                selector: 'chain-app-risks-table',
                templateUrl: './risks-table.component.html',
                styleUrls: ['./risks-table.component.scss']
            }]
    }], function () { return [{ type: RiskService, decorators: [{
                type: Inject,
                args: [forwardRef(() => RiskService)]
            }] }]; }, { displayedColumns: [{
            type: Input
        }], customColumns: [{
            type: Input
        }], projectId: [{
            type: Input
        }], dataSource: [{
            type: Input
        }], action: [{
            type: Output
        }], paginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }], sort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }] }); })();

function AddressComponent_mat_option_33_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-option", 15);
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const country_r1 = ctx.$implicit;
    ɵɵproperty("value", country_r1.iso);
    ɵɵadvance(1);
    ɵɵtextInterpolate2(" ", country_r1.name, " (", country_r1.iso, ") ");
} }
class AddressComponent {
    constructor() {
        this.countries = [];
    }
    ngOnInit() {
    }
}
/** @nocollapse */ AddressComponent.ɵfac = function AddressComponent_Factory(t) { return new (t || AddressComponent)(); };
/** @nocollapse */ AddressComponent.ɵcmp = ɵɵdefineComponent({ type: AddressComponent, selectors: [["chain-app-address"]], inputs: { formGroup: "formGroup", countries: "countries" }, decls: 34, vars: 17, consts: [[3, "formGroup"], [1, "form-row"], [1, "col65"], ["appearance", "outline", "floatLabel", "always", 1, "field-wrap"], ["matInput", "", "formControlName", "street", "name", "firstName"], [1, "col33"], ["matInput", "", "formControlName", "houseNumber"], [1, "col20"], ["matInput", "", "formControlName", "zipCode"], [1, "col50"], ["matInput", "", "formControlName", "city", "name", "firstName"], [1, "col30"], [1, "field-wrap"], ["ngDefaultControl", "", "formControlName", "countryCode", "name", "countryCode"], [3, "value", 4, "ngFor", "ngForOf"], [3, "value"]], template: function AddressComponent_Template(rf, ctx) { if (rf & 1) {
        ɵɵelementStart(0, "form", 0);
        ɵɵelementStart(1, "div", 1);
        ɵɵelementStart(2, "div", 2);
        ɵɵelementStart(3, "div", 3);
        ɵɵelementStart(4, "mat-label");
        ɵɵtext(5);
        ɵɵpipe(6, "translate");
        ɵɵelementEnd();
        ɵɵelement(7, "input", 4);
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementStart(8, "div", 5);
        ɵɵelementStart(9, "div", 3);
        ɵɵelementStart(10, "mat-label");
        ɵɵtext(11);
        ɵɵpipe(12, "translate");
        ɵɵelementEnd();
        ɵɵelement(13, "input", 6);
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementStart(14, "div", 1);
        ɵɵelementStart(15, "div", 7);
        ɵɵelementStart(16, "div", 3);
        ɵɵelementStart(17, "mat-label");
        ɵɵtext(18);
        ɵɵpipe(19, "translate");
        ɵɵelementEnd();
        ɵɵelement(20, "input", 8);
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementStart(21, "div", 9);
        ɵɵelementStart(22, "div", 3);
        ɵɵelementStart(23, "mat-label");
        ɵɵtext(24);
        ɵɵpipe(25, "translate");
        ɵɵelementEnd();
        ɵɵelement(26, "input", 10);
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementStart(27, "div", 11);
        ɵɵelementStart(28, "div", 12);
        ɵɵelementStart(29, "mat-label");
        ɵɵtext(30);
        ɵɵpipe(31, "translate");
        ɵɵelementEnd();
        ɵɵelementStart(32, "mat-select", 13);
        ɵɵtemplate(33, AddressComponent_mat_option_33_Template, 2, 3, "mat-option", 14);
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
        ɵɵelementEnd();
    } if (rf & 2) {
        ɵɵproperty("formGroup", ctx.formGroup);
        ɵɵadvance(5);
        ɵɵtextInterpolate1("", ɵɵpipeBind1(6, 7, "ADDRESS.STREET"), " ");
        ɵɵadvance(6);
        ɵɵtextInterpolate1("", ɵɵpipeBind1(12, 9, "ADDRESS.STREET_NUMBER"), " ");
        ɵɵadvance(7);
        ɵɵtextInterpolate1("", ɵɵpipeBind1(19, 11, "ADDRESS.POST_CODE"), " ");
        ɵɵadvance(6);
        ɵɵtextInterpolate1("", ɵɵpipeBind1(25, 13, "ADDRESS.CITY"), " ");
        ɵɵadvance(6);
        ɵɵtextInterpolate1("", ɵɵpipeBind1(31, 15, "ADDRESS.COUNTRY"), " ");
        ɵɵadvance(3);
        ɵɵproperty("ngForOf", ctx.countries);
    } }, directives: [ɵangular_packages_forms_forms_y, NgControlStatusGroup, FormGroupDirective, MatLabel, DefaultValueAccessor, NgControlStatus, FormControlName, MatSelect, NgForOf, MatOption], pipes: [TranslatePipe], styles: [""], encapsulation: 2 });
/*@__PURE__*/ (function () { ɵsetClassMetadata(AddressComponent, [{
        type: Component,
        args: [{
                selector: 'chain-app-address',
                templateUrl: './address.component.html',
                styleUrls: ['./address.component.scss'],
                encapsulation: ViewEncapsulation.None
            }]
    }], function () { return []; }, { formGroup: [{
            type: Input
        }], countries: [{
            type: Input
        }] }); })();

var AddressType;
(function (AddressType) {
    AddressType["INVOICE"] = "INVOICE";
    AddressType["HOME"] = "HOME";
})(AddressType || (AddressType = {}));
const addressTypes = [];
for (let n in AddressType) {
    addressTypes.push(AddressType[n]);
}

class AttachmentTableQueryStore extends QueryTableSource {
    constructor(service, paginator, sort, tableFilter) {
        super(paginator, sort, tableFilter);
        this.service = service;
        this.paginator = paginator;
        this.sort = sort;
        this.tableFilter = tableFilter;
        this.filterSubject = new BehaviorSubject(tableFilter);
    }
    queryTable() {
        let filter = this.findFilter();
        this.applyFilter(filter);
        if (filter.keyword)
            filter.keyword += '*';
        return this.service.query(filter);
    }
}

function AttachmentTableComponent_mat_header_cell_8_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 20);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "ATTACHMENT.ID"));
} }
function AttachmentTableComponent_mat_cell_9_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r21 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r21 == null ? null : row_r21.attachmentId);
} }
function AttachmentTableComponent_mat_header_cell_11_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 20);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "ATTACHMENT.CATEGORY"));
} }
function AttachmentTableComponent_mat_cell_12_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r22 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r22 == null ? null : row_r22.category);
} }
function AttachmentTableComponent_mat_header_cell_14_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 20);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "ATTACHMENT.NAME"));
} }
function AttachmentTableComponent_mat_cell_15_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r23 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r23.file == null ? null : row_r23.file.fileName);
} }
function AttachmentTableComponent_mat_header_cell_17_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 20);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "ATTACHMENT.FILE_SIZE"));
} }
function AttachmentTableComponent_mat_cell_18_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span");
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r24 = ctx.$implicit;
    ɵɵadvance(2);
    ɵɵtextInterpolate(row_r24.file == null ? null : row_r24.file.fileSize);
} }
function AttachmentTableComponent_mat_header_cell_20_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 20);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "FEP.STATUS"));
} }
function AttachmentTableComponent_mat_cell_21_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelementStart(1, "span", 21);
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r25 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("matTooltip", row_r25.fepStatus.userIds);
    ɵɵadvance(1);
    ɵɵtextInterpolate(row_r25.fepStatus == null ? null : row_r25.fepStatus.status);
} }
function AttachmentTableComponent_mat_header_cell_23_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 20);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "COMMON.CREATED_DATE"));
} }
function AttachmentTableComponent_mat_cell_24_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelement(1, "base-date", 22);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r26 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("data", row_r26.created == null ? null : row_r26.created.date)("matTooltip", row_r26.created == null ? null : row_r26.created.user);
} }
function AttachmentTableComponent_mat_header_cell_26_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell", 20);
    ɵɵtext(1);
    ɵɵpipe(2, "translate");
    ɵɵelementEnd();
} if (rf & 2) {
    ɵɵadvance(1);
    ɵɵtextInterpolate(ɵɵpipeBind1(2, 1, "COMMON.CHANGE_DATE"));
} }
function AttachmentTableComponent_mat_cell_27_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵelement(1, "base-date", 22);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r27 = ctx.$implicit;
    ɵɵadvance(1);
    ɵɵproperty("data", row_r27.change == null ? null : row_r27.change.date)("matTooltip", row_r27.change == null ? null : row_r27.change.user);
} }
function AttachmentTableComponent_ng_container_28_mat_header_cell_1_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-header-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const column_r28 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate(column_r28.header);
} }
function AttachmentTableComponent_ng_container_28_mat_cell_2_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r32 = ctx.$implicit;
    const column_r28 = ɵɵnextContext().$implicit;
    ɵɵadvance(1);
    ɵɵtextInterpolate(column_r28.cell(row_r32));
} }
function AttachmentTableComponent_ng_container_28_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementContainerStart(0, 23);
    ɵɵtemplate(1, AttachmentTableComponent_ng_container_28_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 24);
    ɵɵtemplate(2, AttachmentTableComponent_ng_container_28_mat_cell_2_Template, 2, 1, "mat-cell", 25);
    ɵɵelementContainerEnd();
} if (rf & 2) {
    const column_r28 = ctx.$implicit;
    ɵɵproperty("cdkColumnDef", column_r28.columnDef);
} }
function AttachmentTableComponent_mat_header_cell_30_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "mat-header-cell");
} }
function AttachmentTableComponent_mat_cell_31_button_1_Template(rf, ctx) { if (rf & 1) {
    const _r41 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "button", 30);
    ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_1_Template_button_click_0_listener($event) { ɵɵrestoreView(_r41); const row_r34 = ɵɵnextContext().$implicit; const ctx_r39 = ɵɵnextContext(); ctx_r39.onAction("delete", row_r34); return $event.stopPropagation(); });
    ɵɵelementStart(1, "mat-icon", 31);
    ɵɵtext(2, "delete");
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = ɵɵnextContext().$implicit;
    const ctx_r35 = ɵɵnextContext();
    ɵɵpropertyInterpolate("disabled", ctx_r35.isDisabled("delete", row_r34));
} }
function AttachmentTableComponent_mat_cell_31_button_2_Template(rf, ctx) { if (rf & 1) {
    const _r45 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "button", 32);
    ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_2_Template_button_click_0_listener($event) { ɵɵrestoreView(_r45); const row_r34 = ɵɵnextContext().$implicit; const ctx_r43 = ɵɵnextContext(); ctx_r43.onAction("request", row_r34); return $event.stopPropagation(); });
    ɵɵelementStart(1, "mat-icon", 33);
    ɵɵtext(2, "send");
    ɵɵelementEnd();
    ɵɵelementEnd();
} }
function AttachmentTableComponent_mat_cell_31_button_3_Template(rf, ctx) { if (rf & 1) {
    const _r48 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "button", 34);
    ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_3_Template_button_click_0_listener($event) { ɵɵrestoreView(_r48); const row_r34 = ɵɵnextContext().$implicit; const ctx_r46 = ɵɵnextContext(); ctx_r46.onAction("confirm", row_r34); return $event.stopPropagation(); });
    ɵɵelementStart(1, "mat-icon", 33);
    ɵɵtext(2, "check");
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = ɵɵnextContext().$implicit;
    const ctx_r37 = ɵɵnextContext();
    ɵɵproperty("disabled", ctx_r37.isDisabled("confirm", row_r34));
} }
function AttachmentTableComponent_mat_cell_31_button_4_Template(rf, ctx) { if (rf & 1) {
    const _r52 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "button", 35);
    ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_4_Template_button_click_0_listener($event) { ɵɵrestoreView(_r52); const row_r34 = ɵɵnextContext().$implicit; const ctx_r50 = ɵɵnextContext(); ctx_r50.onAction("reject", row_r34); return $event.stopPropagation(); });
    ɵɵelementStart(1, "mat-icon", 33);
    ɵɵtext(2, "backspace");
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = ɵɵnextContext().$implicit;
    const ctx_r38 = ɵɵnextContext();
    ɵɵproperty("disabled", ctx_r38.isDisabled("reject", row_r34));
} }
function AttachmentTableComponent_mat_cell_31_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "mat-cell");
    ɵɵtemplate(1, AttachmentTableComponent_mat_cell_31_button_1_Template, 3, 1, "button", 26);
    ɵɵtemplate(2, AttachmentTableComponent_mat_cell_31_button_2_Template, 3, 0, "button", 27);
    ɵɵtemplate(3, AttachmentTableComponent_mat_cell_31_button_3_Template, 3, 1, "button", 28);
    ɵɵtemplate(4, AttachmentTableComponent_mat_cell_31_button_4_Template, 3, 1, "button", 29);
    ɵɵelementEnd();
} if (rf & 2) {
    const row_r34 = ctx.$implicit;
    const ctx_r18 = ɵɵnextContext();
    ɵɵadvance(1);
    ɵɵproperty("ngIf", ctx_r18.showAction("delete", row_r34));
    ɵɵadvance(1);
    ɵɵproperty("ngIf", ctx_r18.showAction("request", row_r34));
    ɵɵadvance(1);
    ɵɵproperty("ngIf", ctx_r18.showAction("confirm", row_r34));
    ɵɵadvance(1);
    ɵɵproperty("ngIf", ctx_r18.showAction("reject", row_r34));
} }
function AttachmentTableComponent_mat_header_row_32_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "mat-header-row");
} }
function AttachmentTableComponent_mat_row_33_Template(rf, ctx) { if (rf & 1) {
    const _r56 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "mat-row", 36);
    ɵɵlistener("click", function AttachmentTableComponent_mat_row_33_Template_mat_row_click_0_listener() { ɵɵrestoreView(_r56); const row_r54 = ctx.$implicit; const ctx_r55 = ɵɵnextContext(); return ctx_r55.onAction("select", row_r54); });
    ɵɵelementEnd();
} }
const _c0$3 = function () { return [5, 10, 25, 100]; };
const _c1$2 = ["*"];
const TAG$2 = 'AttachmentTableComponent';
class AttachmentTableComponent {
    constructor(_service) {
        this._service = _service;
        this.displayedColumns = [
            'file.fileId', 'file.fileName', 'file.fileSize',
            'category', 'change.date', 'fepStatus.status'
        ];
        this.customColumns = [];
        this.showFep = true;
        this.filter = {};
        this.action = new EventEmitter();
        //protected _auth : AuthService
    }
    ngOnInit() {
        if (this.customColumns && this.customColumns.length > 0) {
            let abc = this.customColumns.map(c => c.columnDef);
            this.displayedColumns.push(...abc);
            this.displayedColumns.push("actions");
        }
        else {
            this.displayedColumns.push("actions");
        }
        let filter = this.filter;
        if (!this.dataSource) {
            this.dataSource = new AttachmentTableQueryStore(this._service, this.paginator, this.sort, filter);
        }
    }
    reload() {
        this.dataSource.reload();
    }
    onAction(type, payload) {
        this.action.emit({ type: type, value: payload });
    }
    isDisabled(action, row) {
        if ('delete' == action && row.fepStatus.status && Fep.CONFIRMED == row.fepStatus.status) {
            // @toDo * [ww] check admin
            //console.log(TAG, "isDisabled", this._auth.getUserRoles())
            return false; //!this._auth.isAdmin(); // admin can always delete
        }
        else if ('confirm' == action && row.fepStatus.status && Fep.WAIT_FOR_CONFIRM == row.fepStatus.status) {
            // check if user not already confirmed
            return false; //row.fepStatus.userIds && row.fepStatus.userIds.indexOf(this._auth.getUserName()) !== -1;
        }
        return false;
    }
    showAction(action, row) {
        if (this.displayedActions && this.displayedActions.indexOf(action) == -1)
            return false;
        // @toDo * [ww] check user roles
        if ('delete' == action)
            return true;
        if (['confirm', 'request', 'reject'].indexOf(action) !== -1 && this.showFep && row.fepStatus) {
            let fs = row.fepStatus.status;
            if ('request' == action)
                return false; // never show request for now
            //return Fep.NEW == fs || Fep.REJECTED == fs;
            else if ('confirm' == action)
                return Fep.WAIT_FOR_CONFIRM == fs; //&& this._auth.hasAnyRole([Yukawa_LeanRealm.ROLE_INVOICE_FEP_CONFIRM, Yukawa_LeanRealm.ROLE_INVOICE_FEP_CONFIRM_PARTIAL]);
            else if ('reject' == action)
                return Fep.WAIT_FOR_CONFIRM == fs; //&& this._auth.hasRole(Yukawa_LeanRealm.ROLE_INVOICE_FEP_REJECT);
        }
        return true;
    }
    showFepButton(action, row) {
        if (!this.showFep || !row.fepStatus)
            return false;
        if ('request' == action)
            return Fep.NEW == row.fepStatus.status || Fep.REJECTED == row.fepStatus.status;
        else if ('confirm' == action || 'reject' == action)
            return Fep.WAIT_FOR_CONFIRM == row.fepStatus.status;
        return false;
    }
}
/** @nocollapse */ AttachmentTableComponent.ɵfac = function AttachmentTableComponent_Factory(t) { return new (t || AttachmentTableComponent)(ɵɵdirectiveInject(forwardRef(() => AttachmentService))); };
/** @nocollapse */ AttachmentTableComponent.ɵcmp = ɵɵdefineComponent({ type: AttachmentTableComponent, selectors: [["tracker-attachment-table"]], viewQuery: function AttachmentTableComponent_Query(rf, ctx) { if (rf & 1) {
        ɵɵstaticViewQuery(MatPaginator, true);
        ɵɵstaticViewQuery(MatSort, true);
    } if (rf & 2) {
        let _t;
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.paginator = _t.first);
        ɵɵqueryRefresh(_t = ɵɵloadQuery()) && (ctx.sort = _t.first);
    } }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", displayedActions: "displayedActions", showFep: "showFep", filter: "filter", dataSource: "dataSource" }, outputs: { action: "action" }, ngContentSelectors: _c1$2, decls: 34, vars: 8, consts: [[1, "table-layout-1"], ["fxLayoutAlign", "space-between center", 1, ""], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortActive", "change.date", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "file.fileId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "category"], ["matColumnDef", "file.fileName"], ["matColumnDef", "file.fileSize"], ["matColumnDef", "fepStatus.status"], ["matColumnDef", "created.date"], ["matColumnDef", "change.date"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "actions"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [3, "matTooltip"], ["format", "date", "formatTip", "false", 3, "data", "matTooltip"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-raised-button", "", "matTooltip", "Delete", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Request confirmation", 3, "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Confirm", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Reject", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Delete", 3, "disabled", "click"], ["color", "warn"], ["mat-raised-button", "", "matTooltip", "Request confirmation", 3, "click"], ["color", "accent"], ["mat-raised-button", "", "matTooltip", "Confirm", 3, "disabled", "click"], ["mat-raised-button", "", "matTooltip", "Reject", 3, "disabled", "click"], [3, "click"]], template: function AttachmentTableComponent_Template(rf, ctx) { if (rf & 1) {
        ɵɵprojectionDef();
        ɵɵelementStart(0, "div", 0);
        ɵɵelementStart(1, "mat-toolbar", 1);
        ɵɵprojection(2);
        ɵɵelement(3, "mat-paginator", 2, 3);
        ɵɵelementEnd();
        ɵɵelementStart(5, "mat-table", 4, 5);
        ɵɵelementContainerStart(7, 6);
        ɵɵtemplate(8, AttachmentTableComponent_mat_header_cell_8_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(9, AttachmentTableComponent_mat_cell_9_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(10, 9);
        ɵɵtemplate(11, AttachmentTableComponent_mat_header_cell_11_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(12, AttachmentTableComponent_mat_cell_12_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(13, 10);
        ɵɵtemplate(14, AttachmentTableComponent_mat_header_cell_14_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(15, AttachmentTableComponent_mat_cell_15_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(16, 11);
        ɵɵtemplate(17, AttachmentTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(18, AttachmentTableComponent_mat_cell_18_Template, 3, 1, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(19, 12);
        ɵɵtemplate(20, AttachmentTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(21, AttachmentTableComponent_mat_cell_21_Template, 3, 2, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(22, 13);
        ɵɵtemplate(23, AttachmentTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(24, AttachmentTableComponent_mat_cell_24_Template, 2, 2, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵelementContainerStart(25, 14);
        ɵɵtemplate(26, AttachmentTableComponent_mat_header_cell_26_Template, 3, 3, "mat-header-cell", 7);
        ɵɵtemplate(27, AttachmentTableComponent_mat_cell_27_Template, 2, 2, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵtemplate(28, AttachmentTableComponent_ng_container_28_Template, 3, 1, "ng-container", 15);
        ɵɵelementContainerStart(29, 16);
        ɵɵtemplate(30, AttachmentTableComponent_mat_header_cell_30_Template, 1, 0, "mat-header-cell", 17);
        ɵɵtemplate(31, AttachmentTableComponent_mat_cell_31_Template, 5, 4, "mat-cell", 8);
        ɵɵelementContainerEnd();
        ɵɵtemplate(32, AttachmentTableComponent_mat_header_row_32_Template, 1, 0, "mat-header-row", 18);
        ɵɵtemplate(33, AttachmentTableComponent_mat_row_33_Template, 1, 0, "mat-row", 19);
        ɵɵelementEnd();
        ɵɵelementEnd();
    } if (rf & 2) {
        ɵɵadvance(3);
        ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", ɵɵpureFunction0(7, _c0$3));
        ɵɵadvance(2);
        ɵɵproperty("dataSource", ctx.dataSource);
        ɵɵadvance(23);
        ɵɵproperty("ngForOf", ctx.customColumns);
        ɵɵadvance(4);
        ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
        ɵɵadvance(1);
        ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
    } }, directives: [DefaultLayoutAlignDirective, MatPaginator, MatTable, MatSort, MatColumnDef, MatHeaderCellDef, MatCellDef, NgForOf, MatHeaderRowDef, MatRowDef, MatHeaderCell, MatSortHeader, MatCell, MatTooltip, CdkColumnDef, CdkHeaderCellDef, CdkCellDef, NgIf, MatButton, MatIcon, MatHeaderRow, MatRow], pipes: [TranslatePipe], encapsulation: 2 });
/*@__PURE__*/ (function () { ɵsetClassMetadata(AttachmentTableComponent, [{
        type: Component,
        args: [{
                selector: 'tracker-attachment-table',
                templateUrl: './attachment-table.component.html',
                styleUrls: [ /*'./attachment-table.component.scss'*/]
            }]
    }], function () { return [{ type: AttachmentService, decorators: [{
                type: Inject,
                args: [forwardRef(() => AttachmentService)]
            }] }]; }, { displayedColumns: [{
            type: Input
        }], customColumns: [{
            type: Input
        }], displayedActions: [{
            type: Input
        }], showFep: [{
            type: Input
        }], filter: [{
            type: Input
        }], dataSource: [{
            type: Input
        }], action: [{
            type: Output
        }], paginator: [{
            type: ViewChild,
            args: [MatPaginator, { static: true }]
        }], sort: [{
            type: ViewChild,
            args: [MatSort, { static: true }]
        }] }); })();

// modules
// services
class TrackerCompModule {
}
/** @nocollapse */ TrackerCompModule.ɵmod = ɵɵdefineNgModule({ type: TrackerCompModule });
/** @nocollapse */ TrackerCompModule.ɵinj = ɵɵdefineInjector({ factory: function TrackerCompModule_Factory(t) { return new (t || TrackerCompModule)(); }, providers: [], imports: [[
            CommonModule,
            FormsModule,
            ReactiveFormsModule,
            MatButtonModule,
            MatIconModule,
            MatRippleModule,
            MatSlideToggleModule,
            MatTableModule,
            MatSortModule,
            MatTooltipModule,
            FlexLayoutModule,
            MatMenuModule,
            MatCheckboxModule,
            HttpClientModule,
            MatPaginatorModule,
            MatSelectModule,
            CdkTableModule,
            TranslateModule.forChild()
        ]] });
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && ɵɵsetNgModuleScope(TrackerCompModule, { declarations: [ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent], imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule,
        MatButtonModule,
        MatIconModule,
        MatRippleModule,
        MatSlideToggleModule,
        MatTableModule,
        MatSortModule,
        MatTooltipModule,
        FlexLayoutModule,
        MatMenuModule,
        MatCheckboxModule,
        HttpClientModule,
        MatPaginatorModule,
        MatSelectModule,
        CdkTableModule, TranslateModule], exports: [ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent] }); })();
/*@__PURE__*/ (function () { ɵsetClassMetadata(TrackerCompModule, [{
        type: NgModule,
        args: [{
                imports: [
                    CommonModule,
                    FormsModule,
                    ReactiveFormsModule,
                    MatButtonModule,
                    MatIconModule,
                    MatRippleModule,
                    MatSlideToggleModule,
                    MatTableModule,
                    MatSortModule,
                    MatTooltipModule,
                    FlexLayoutModule,
                    MatMenuModule,
                    MatCheckboxModule,
                    HttpClientModule,
                    MatPaginatorModule,
                    MatSelectModule,
                    CdkTableModule,
                    TranslateModule.forChild()
                ],
                declarations: [
                    ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent
                ],
                exports: [
                    ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent
                ],
                providers: [],
                entryComponents: [],
                schemas: [CUSTOM_ELEMENTS_SCHEMA]
            }]
    }], null, null); })();

/*
 * Public API
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AddressComponent, AddressType, AttachmentTableComponent, AttachmentTableQueryStore, ProjectQueryStore, ProjectSheetQueryStore, ProjectSheetTableComponent, ProjectTableComponent, RisksTableComponent, RisksTableQueryStore, TrackerCompModule, addressTypes };
//# sourceMappingURL=yukawa-chain-tracker-angular-comp.js.map
