(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material/sort'), require('@angular/material/paginator'), require('@yukawa/chain-crm-angular-core'), require('@yukawa/chain-tracker-angular-core'), require('@angular/material/table'), require('@angular/common'), require('@angular/material/tooltip'), require('@angular/flex-layout/flex'), require('@angular/cdk/table'), require('@ngx-translate/core'), require('@yukawa/chain-base-angular-store'), require('rxjs'), require('rxjs/operators'), require('@angular/router'), require('@angular/material/icon'), require('@angular/flex-layout/extended'), require('@angular/material/button'), require('@angular/forms'), require('@angular/material/form-field'), require('@angular/material/select'), require('@angular/material/core'), require('@angular/flex-layout'), require('@angular/common/http'), require('@angular/material/slide-toggle'), require('@angular/material/menu'), require('@angular/material/checkbox')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-tracker-angular-comp', ['exports', '@angular/core', '@angular/material/sort', '@angular/material/paginator', '@yukawa/chain-crm-angular-core', '@yukawa/chain-tracker-angular-core', '@angular/material/table', '@angular/common', '@angular/material/tooltip', '@angular/flex-layout/flex', '@angular/cdk/table', '@ngx-translate/core', '@yukawa/chain-base-angular-store', 'rxjs', 'rxjs/operators', '@angular/router', '@angular/material/icon', '@angular/flex-layout/extended', '@angular/material/button', '@angular/forms', '@angular/material/form-field', '@angular/material/select', '@angular/material/core', '@angular/flex-layout', '@angular/common/http', '@angular/material/slide-toggle', '@angular/material/menu', '@angular/material/checkbox'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-tracker-angular-comp'] = {}), global.ng.core, global.ng.material.sort, global.ng.material.paginator, global.chainCrmAngularCore, global.i1, global.ng.material.table, global.ng.common, global.ng.material.tooltip, global.ng.flexLayout.flex, global.ng.cdk.table, global.i8$1, global.chainBaseAngularStore, global.rxjs, global.rxjs.operators, global.ng.router, global.ng.material.icon, global.ng.flexLayout.extended, global.ng.material.button, global.ng.forms, global.ng.material.formField, global.ng.material.select, global.ng.material.core, global.ng.flexLayout, global.ng.common.http, global.ng.material.slideToggle, global.ng.material.menu, global.ng.material.checkbox));
}(this, (function (exports, i0, i5, i3, chainCrmAngularCore, i1, i4, i8, i5$1, i3$1, i7, i8$1, chainBaseAngularStore, rxjs, operators, i2, i4$1, i9, i11, i1$1, i2$1, i3$2, i5$2, flexLayout, http, slideToggle, menu, checkbox) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __createBinding(o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    }
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                exports[p] = m[p];
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    result[k] = mod[k];
        result.default = mod;
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    function ProjectTableComponent_mat_header_cell_6_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var ctx_r2 = i0.ɵɵnextContext();
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, ctx_r2.getIdHeader()));
        }
    }
    function ProjectTableComponent_mat_cell_7_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span", 25);
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r33 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matTooltip", row_r33.phase);
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate((row_r33.info == null ? null : row_r33.info.shortName) || row_r33.projectId);
        }
    }
    function ProjectTableComponent_mat_header_cell_9_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.ID"));
        }
    }
    function ProjectTableComponent_mat_cell_10_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span", 25);
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r34 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matTooltip", row_r34.phase);
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate((row_r34.info == null ? null : row_r34.info.shortName) || row_r34.projectId);
        }
    }
    function ProjectTableComponent_mat_header_cell_12_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.NAME"));
        }
    }
    function ProjectTableComponent_mat_cell_13_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span", 25);
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r35 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matTooltip", row_r35.info == null ? null : row_r35.info.desc);
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(row_r35.info == null ? null : row_r35.info.name);
        }
    }
    function ProjectTableComponent_mat_header_cell_15_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.CUSTOMER"));
        }
    }
    function ProjectTableComponent_mat_cell_16_div_1_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 27);
            i0.ɵɵelementStart(1, "span", 28);
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r36 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r36 == null ? null : row_r36.customer == null ? null : row_r36.customer.companyName);
        }
    }
    function ProjectTableComponent_mat_cell_16_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtemplate(1, ProjectTableComponent_mat_cell_16_div_1_Template, 3, 1, "div", 26);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r36 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", row_r36.customer);
        }
    }
    function ProjectTableComponent_mat_header_cell_18_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.OWNER"));
        }
    }
    function ProjectTableComponent_mat_cell_19_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r40 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r40 == null ? null : row_r40.change == null ? null : row_r40.change.user);
        }
    }
    function ProjectTableComponent_mat_header_cell_21_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.HEAD_ENGINEER"));
        }
    }
    function ProjectTableComponent_mat_cell_22_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r41 = ctx.$implicit;
            var ctx_r13 = i0.ɵɵnextContext();
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r41.head != null ? ctx_r13.accountUtils.getDisplayName(row_r41.head, ctx_r13.partnerType.PERSON) : "");
        }
    }
    function ProjectTableComponent_mat_header_cell_24_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.START_DATE"));
        }
    }
    function ProjectTableComponent_mat_cell_25_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelement(1, "base-date", 29);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r42 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("data", row_r42.actualStartDate);
        }
    }
    function ProjectTableComponent_mat_header_cell_27_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.END_DATE"));
        }
    }
    function ProjectTableComponent_mat_cell_28_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelement(1, "base-date", 29);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r43 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("data", row_r43.actualEndDate);
        }
    }
    function ProjectTableComponent_mat_header_cell_30_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.START_DATE"));
        }
    }
    function ProjectTableComponent_mat_cell_31_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelement(1, "base-date", 29);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r44 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("data", row_r44.plannedStartDate);
        }
    }
    function ProjectTableComponent_mat_header_cell_33_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.END_DATE"));
        }
    }
    function ProjectTableComponent_mat_cell_34_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelement(1, "base-date", 29);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r45 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("data", row_r45.plannedEndDate);
        }
    }
    function ProjectTableComponent_mat_header_cell_36_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "COMMON.CHANGE_DATE"));
        }
    }
    function ProjectTableComponent_mat_cell_37_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelement(1, "base-date", 30);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r46 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("data", row_r46.change == null ? null : row_r46.change.date)("matTooltip", row_r46.change == null ? null : row_r46.change.user);
        }
    }
    function ProjectTableComponent_mat_header_cell_39_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.PHASE"));
        }
    }
    function ProjectTableComponent_mat_cell_40_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r47 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r47 == null ? null : row_r47.phase);
        }
    }
    function ProjectTableComponent_mat_header_cell_42_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.STATUS"));
        }
    }
    function ProjectTableComponent_mat_cell_43_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r48 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate1(" ", row_r48.status, " ");
        }
    }
    function ProjectTableComponent_mat_header_cell_45_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 24);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.HEADER.ESTIMATED_VOLUME"));
        }
    }
    function ProjectTableComponent_mat_cell_46_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r49 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate((row_r49 == null ? null : row_r49.plannedBudget == null ? null : row_r49.plannedBudget.money) !== null ? row_r49.plannedBudget.money + " \u20AC" : "");
        }
    }
    function ProjectTableComponent_ng_container_47_mat_header_cell_1_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var column_r50 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(column_r50.header);
        }
    }
    function ProjectTableComponent_ng_container_47_mat_cell_2_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r54 = ctx.$implicit;
            var column_r50 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(column_r50.cell(row_r54));
        }
    }
    function ProjectTableComponent_ng_container_47_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementContainerStart(0, 31);
            i0.ɵɵtemplate(1, ProjectTableComponent_ng_container_47_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 32);
            i0.ɵɵtemplate(2, ProjectTableComponent_ng_container_47_mat_cell_2_Template, 2, 1, "mat-cell", 33);
            i0.ɵɵelementContainerEnd();
        }
        if (rf & 2) {
            var column_r50 = ctx.$implicit;
            i0.ɵɵproperty("cdkColumnDef", column_r50.columnDef);
        }
    }
    function ProjectTableComponent_mat_header_row_48_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelement(0, "mat-header-row");
        }
    }
    function ProjectTableComponent_mat_row_49_Template(rf, ctx) {
        if (rf & 1) {
            var _r58_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "mat-row", 34);
            i0.ɵɵlistener("click", function ProjectTableComponent_mat_row_49_Template_mat_row_click_0_listener() { i0.ɵɵrestoreView(_r58_1); var row_r56 = ctx.$implicit; var ctx_r57 = i0.ɵɵnextContext(); return ctx_r57.onAction("edit", row_r56); });
            i0.ɵɵelementEnd();
        }
    }
    var _c0 = function () { return [5, 10, 25, 100]; };
    var TAG = 'ProjectTableComponent';
    var ProjectTableComponent = /** @class */ (function () {
        function ProjectTableComponent() {
            this.displayedColumns = ['projectId', 'phase', 'info.name', 'customer.companyName', 'created.user', 'head', 'actualStartDate', 'actualEndDate', 'plannedBudget.money'];
            this.customColumns = [];
            this.action = new i0.EventEmitter();
            this.accountUtils = chainCrmAngularCore.AccountUtilities;
            this.partnerType = chainCrmAngularCore.PartnerType;
        }
        ProjectTableComponent.prototype.ngOnInit = function () {
            var _a;
            if (this.customColumns && this.customColumns.length > 0) {
                var abc = this.customColumns.map(function (c) { return c.columnDef; });
                (_a = this.displayedColumns).push.apply(_a, __spread(abc));
            }
            else {
            }
        };
        /**
         * On destroy
         */
        ProjectTableComponent.prototype.ngOnDestroy = function () {
            this.action.complete();
        };
        ProjectTableComponent.prototype.onAction = function (type, project) {
            if (type === void 0) { type = ""; }
            if (i0.isDevMode()) {
                console.debug(TAG, "onAction", project);
            }
            event.stopPropagation();
            this.fireAction({ type: type, project: project });
        };
        ProjectTableComponent.prototype.fireAction = function (action) {
            this.action.emit(action);
        };
        ProjectTableComponent.prototype.onOverlayAction = function (action) {
            if (action === 'close') {
                this.partnerDetailsRowId = "";
            }
        };
        ProjectTableComponent.prototype.getIdHeader = function () {
            // return  this.onAction("getIdHeader",null)
            return i1.ProjectPhase.PHASE_LEAD;
            // let phase = this._route.snapshot.params.phase
            // switch (phase) {
            //     case ProjectPhase.PHASE_LEAD:
            //         return "PROJECT.HEADER.LEAD_ID"
            //     case ProjectPhase.PHASE_PROJECT:
            //         return "PROJECT.HEADER.PROJECT_ID"
            //     case ProjectPhase.PHASE_PROPOSAL:
            //         return "PROJECT.HEADER.OPPORTUNITY_ID";
            //     default:
            //         return "PROJECT.HEADER.ID";
            // }
        };
        return ProjectTableComponent;
    }());
    /** @nocollapse */ ProjectTableComponent.ɵfac = function ProjectTableComponent_Factory(t) { return new (t || ProjectTableComponent)(); };
    /** @nocollapse */ ProjectTableComponent.ɵcmp = i0.ɵɵdefineComponent({ type: ProjectTableComponent, selectors: [["chain-tracker-project-table"]], viewQuery: function ProjectTableComponent_Query(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵstaticViewQuery(i3.MatPaginator, true);
                i0.ɵɵstaticViewQuery(i5.MatSort, true);
            }
            if (rf & 2) {
                var _t = void 0;
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
            }
        }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", dataSource: "dataSource" }, outputs: { action: "action" }, decls: 50, vars: 8, consts: [[1, "table-layout-1"], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortActive", "actualStartDate", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "projectId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "info.shortName"], ["matColumnDef", "info.name", 1, "mat-column-info-name"], ["matColumnDef", "customer.companyName"], ["matColumnDef", "created.user", 1, "mat-column-owner"], ["matColumnDef", "head"], ["matColumnDef", "actualStartDate"], ["matColumnDef", "actualEndDate"], ["matColumnDef", "plannedStartDate"], ["matColumnDef", "plannedEndDate"], ["matColumnDef", "changed.date"], ["matColumnDef", "phase"], ["matColumnDef", "status"], ["matColumnDef", "plannedBudget.money"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [3, "matTooltip"], ["fxLayoutAlign", "none center", 4, "ngIf"], ["fxLayoutAlign", "none center"], ["fxFlex", "90", 1, "customer-name"], ["format", "day", "formatTip", "false", 3, "data"], ["format", "date", "formatTip", "false", 3, "data", "matTooltip"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], [3, "click"]], template: function ProjectTableComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵelementStart(0, "div", 0);
                i0.ɵɵelement(1, "mat-paginator", 1, 2);
                i0.ɵɵelementStart(3, "mat-table", 3, 4);
                i0.ɵɵelementContainerStart(5, 5);
                i0.ɵɵtemplate(6, ProjectTableComponent_mat_header_cell_6_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(7, ProjectTableComponent_mat_cell_7_Template, 3, 2, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(8, 8);
                i0.ɵɵtemplate(9, ProjectTableComponent_mat_header_cell_9_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(10, ProjectTableComponent_mat_cell_10_Template, 3, 2, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(11, 9);
                i0.ɵɵtemplate(12, ProjectTableComponent_mat_header_cell_12_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(13, ProjectTableComponent_mat_cell_13_Template, 3, 2, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(14, 10);
                i0.ɵɵtemplate(15, ProjectTableComponent_mat_header_cell_15_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(16, ProjectTableComponent_mat_cell_16_Template, 2, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(17, 11);
                i0.ɵɵtemplate(18, ProjectTableComponent_mat_header_cell_18_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(19, ProjectTableComponent_mat_cell_19_Template, 3, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(20, 12);
                i0.ɵɵtemplate(21, ProjectTableComponent_mat_header_cell_21_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(22, ProjectTableComponent_mat_cell_22_Template, 3, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(23, 13);
                i0.ɵɵtemplate(24, ProjectTableComponent_mat_header_cell_24_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(25, ProjectTableComponent_mat_cell_25_Template, 2, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(26, 14);
                i0.ɵɵtemplate(27, ProjectTableComponent_mat_header_cell_27_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(28, ProjectTableComponent_mat_cell_28_Template, 2, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(29, 15);
                i0.ɵɵtemplate(30, ProjectTableComponent_mat_header_cell_30_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(31, ProjectTableComponent_mat_cell_31_Template, 2, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(32, 16);
                i0.ɵɵtemplate(33, ProjectTableComponent_mat_header_cell_33_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(34, ProjectTableComponent_mat_cell_34_Template, 2, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(35, 17);
                i0.ɵɵtemplate(36, ProjectTableComponent_mat_header_cell_36_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(37, ProjectTableComponent_mat_cell_37_Template, 2, 2, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(38, 18);
                i0.ɵɵtemplate(39, ProjectTableComponent_mat_header_cell_39_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(40, ProjectTableComponent_mat_cell_40_Template, 3, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(41, 19);
                i0.ɵɵtemplate(42, ProjectTableComponent_mat_header_cell_42_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(43, ProjectTableComponent_mat_cell_43_Template, 2, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(44, 20);
                i0.ɵɵtemplate(45, ProjectTableComponent_mat_header_cell_45_Template, 3, 3, "mat-header-cell", 6);
                i0.ɵɵtemplate(46, ProjectTableComponent_mat_cell_46_Template, 3, 1, "mat-cell", 7);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵtemplate(47, ProjectTableComponent_ng_container_47_Template, 3, 1, "ng-container", 21);
                i0.ɵɵtemplate(48, ProjectTableComponent_mat_header_row_48_Template, 1, 0, "mat-header-row", 22);
                i0.ɵɵtemplate(49, ProjectTableComponent_mat_row_49_Template, 1, 0, "mat-row", 23);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(7, _c0));
                i0.ɵɵadvance(2);
                i0.ɵɵproperty("dataSource", ctx.dataSource);
                i0.ɵɵadvance(44);
                i0.ɵɵproperty("ngForOf", ctx.customColumns);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
            }
        }, directives: [i3.MatPaginator, i4.MatTable, i5.MatSort, i4.MatColumnDef, i4.MatHeaderCellDef, i4.MatCellDef, i8.NgForOf, i4.MatHeaderRowDef, i4.MatRowDef, i4.MatHeaderCell, i5.MatSortHeader, i4.MatCell, i5$1.MatTooltip, i8.NgIf, i3$1.DefaultLayoutAlignDirective, i3$1.DefaultFlexDirective, i7.CdkColumnDef, i7.CdkHeaderCellDef, i7.CdkCellDef, i4.MatHeaderRow, i4.MatRow], pipes: [i8$1.TranslatePipe], styles: ["chain-tracker-project-table{width:100%!important}chain-tracker-project-table .mat-table{background:transparent;box-shadow:none}chain-tracker-project-table .mat-table .mat-row{cursor:pointer!important;min-height:64px;position:relative}chain-tracker-project-table .info-icon{padding-right:5px}chain-tracker-project-table .customer-name{margin-right:20px!important}chain-tracker-project-table .mat-column-customer{flex:0 0 18%!important;white-space:unset!important;width:18%!important}chain-tracker-project-table .mat-column-customer,chain-tracker-project-table .mat-column-info-name{-ms-hyphens:auto;-webkit-hyphens:auto;hyphens:auto;overflow-wrap:break-word;word-break:break-word;word-wrap:break-word}chain-tracker-project-table .mat-column-info-name{flex:0 0 15%!important;white-space:nowrap!important;width:15%!important}chain-tracker-project-table .mat-column-created-user{-ms-hyphens:auto;-webkit-hyphens:auto;flex:0 0 12%!important;hyphens:auto;overflow-wrap:break-word;white-space:unset!important;width:12%!important;word-break:break-word;word-wrap:break-word}chain-tracker-project-table .mat-column-headEngineer,chain-tracker-project-table .mat-column-plannedBudget-money{-ms-hyphens:auto;-webkit-hyphens:auto;hyphens:auto;white-space:pre-wrap}chain-tracker-project-table .mat-column-headEngineer{text-align:center}"], encapsulation: 2 });
    /*@__PURE__*/ (function () {
        i0.ɵsetClassMetadata(ProjectTableComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'chain-tracker-project-table',
                        templateUrl: './project-table.component.html',
                        styleUrls: ['./project-table.component.scss'],
                        encapsulation: i0.ViewEncapsulation.None
                    }]
            }], function () { return []; }, { displayedColumns: [{
                    type: i0.Input
                }], customColumns: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], action: [{
                    type: i0.Output
                }], paginator: [{
                    type: i0.ViewChild,
                    args: [i3.MatPaginator, { static: true }]
                }], sort: [{
                    type: i0.ViewChild,
                    args: [i5.MatSort, { static: true }]
                }] });
    })();

    var ProjectQueryStore = /** @class */ (function (_super) {
        __extends(ProjectQueryStore, _super);
        function ProjectQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        ProjectQueryStore.prototype.queryTable = function () {
            var filter = this.findFilter();
            this.applyFilter(filter);
            //this.applyPaginator(filter, this.paginator)
            if (filter.keyword)
                filter.keyword += '*';
            /*    if (filter.orderBy)
                  filter.orderBy += '.keyword'*/
            return this.service.queryProject(filter);
        };
        return ProjectQueryStore;
    }(chainBaseAngularStore.QueryTableSource));

    var ProjectSheetQueryStore = /** @class */ (function (_super) {
        __extends(ProjectSheetQueryStore, _super);
        function ProjectSheetQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        ProjectSheetQueryStore.prototype.queryTable = function () {
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.queryProjectSheet(filter);
        };
        return ProjectSheetQueryStore;
    }(chainBaseAngularStore.QueryTableSource));

    var _c0$1 = ["projectsheetfilter"];
    function ProjectSheetTableComponent_mat_header_cell_17_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 25);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.REPORT_DATE"), " ");
        }
    }
    function ProjectSheetTableComponent_mat_cell_18_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵpipe(3, "date");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r18 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(3, 1, row_r18.reportDate));
        }
    }
    function ProjectSheetTableComponent_mat_header_cell_20_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 25);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.NAME"));
        }
    }
    function ProjectSheetTableComponent_mat_cell_21_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r19 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r19 == null ? null : row_r19.info == null ? null : row_r19.info.name);
        }
    }
    function ProjectSheetTableComponent_mat_header_cell_23_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 25);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.STATUS"));
        }
    }
    var _c1 = function (a0, a1, a2) { return { "dot-red": a0, "dot-green": a1, "dot-yellow": a2 }; };
    function ProjectSheetTableComponent_mat_cell_24_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelement(1, "span", 26);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r20 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction3(1, _c1, row_r20.status == "red", row_r20.status == "green", row_r20.status == "yellow"));
        }
    }
    function ProjectSheetTableComponent_mat_header_cell_26_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 25);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.PERCENTAGE"));
        }
    }
    function ProjectSheetTableComponent_mat_cell_27_span_1_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "span");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r21 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate1("", row_r21 == null ? null : row_r21.percentageOfCompletion, " %");
        }
    }
    function ProjectSheetTableComponent_mat_cell_27_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtemplate(1, ProjectSheetTableComponent_mat_cell_27_span_1_Template, 2, 1, "span", 27);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r21 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", row_r21.percentageOfCompletion);
        }
    }
    function ProjectSheetTableComponent_mat_header_cell_29_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 25);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.AMOUNT"));
        }
    }
    function ProjectSheetTableComponent_mat_cell_30_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r24 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r24 == null ? null : row_r24.budget == null ? null : row_r24.budget.amount);
        }
    }
    function ProjectSheetTableComponent_ng_container_31_mat_header_cell_1_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var column_r25 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(column_r25.header);
        }
    }
    function ProjectSheetTableComponent_ng_container_31_mat_cell_2_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r29 = ctx.$implicit;
            var column_r25 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(column_r25.cell(row_r29));
        }
    }
    function ProjectSheetTableComponent_ng_container_31_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementContainerStart(0, 28);
            i0.ɵɵtemplate(1, ProjectSheetTableComponent_ng_container_31_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 29);
            i0.ɵɵtemplate(2, ProjectSheetTableComponent_ng_container_31_mat_cell_2_Template, 2, 1, "mat-cell", 30);
            i0.ɵɵelementContainerEnd();
        }
        if (rf & 2) {
            var column_r25 = ctx.$implicit;
            i0.ɵɵproperty("cdkColumnDef", column_r25.columnDef);
        }
    }
    function ProjectSheetTableComponent_mat_header_cell_33_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelement(0, "mat-header-cell");
        }
    }
    function ProjectSheetTableComponent_mat_cell_34_Template(rf, ctx) {
        if (rf & 1) {
            var _r33_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "button", 31);
            i0.ɵɵlistener("click", function ProjectSheetTableComponent_mat_cell_34_Template_button_click_1_listener() { i0.ɵɵrestoreView(_r33_1); var row_r31 = ctx.$implicit; var ctx_r32 = i0.ɵɵnextContext(); return ctx_r32.onAction("delete", row_r31); });
            i0.ɵɵelementStart(2, "mat-icon", 32);
            i0.ɵɵtext(3, " delete ");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
    }
    function ProjectSheetTableComponent_mat_header_row_35_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelement(0, "mat-header-row");
        }
    }
    function ProjectSheetTableComponent_mat_row_36_Template(rf, ctx) {
        if (rf & 1) {
            var _r36_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "mat-row", 33);
            i0.ɵɵlistener("click", function ProjectSheetTableComponent_mat_row_36_Template_mat_row_click_0_listener() { i0.ɵɵrestoreView(_r36_1); var row_r34 = ctx.$implicit; var ctx_r35 = i0.ɵɵnextContext(); return ctx_r35.onAction("edit", row_r34); });
            i0.ɵɵelementEnd();
        }
    }
    var _c2 = function () { return [5, 10, 25, 100]; };
    var _c3 = ["*"];
    var TAG$1 = "ProjectSheetTableComponent";
    var ProjectSheetTableComponent = /** @class */ (function () {
        function ProjectSheetTableComponent(service, _route) {
            this.service = service;
            this._route = _route;
            // routeAnimationsElements = ROUTE_ANIMATIONS_ELEMENTS;
            this.displayedColumns = ['reportDate', 'status', 'percentageOfCompletion', 'budget.amount'];
            this.customColumns = [];
            this.projectSheetFilter = { type: null, projectId: null };
            this.action = new i0.EventEmitter();
        }
        ProjectSheetTableComponent.prototype.ngOnInit = function () {
            var _a;
            var _this = this;
            if (this.customColumns && this.customColumns.length > 0) {
                var abc = this.customColumns.map(function (c) { return c.columnDef; });
                (_a = this.displayedColumns).push.apply(_a, __spread(abc));
                this.displayedColumns.push("action");
            }
            else {
                this.displayedColumns.push("action");
            }
            this._route.params.pipe().subscribe(function (params) {
                _this.projectSheetFilter.projectId = params.projectId;
                _this.dataSource = new ProjectSheetQueryStore(_this.service, _this.paginator, _this.sort, _this.projectSheetFilter);
                rxjs.fromEvent(_this.filter.nativeElement, 'keyup')
                    .pipe(operators.debounceTime(1000), operators.distinctUntilChanged())
                    .subscribe(function (event) {
                    var value = _this.filter.nativeElement.value;
                    if (value == '')
                        value = null;
                    var filter = _this.dataSource.filterSubject.value;
                    filter.keyword = value;
                    _this.applyFilter(filter);
                });
            });
        };
        ProjectSheetTableComponent.prototype.ngOnDestroy = function () {
            this.action.complete();
        };
        ProjectSheetTableComponent.prototype.reload = function (keyword) {
            if (keyword === void 0) { keyword = null; }
            if (keyword)
                this.projectSheetFilter.keyword = keyword;
            this.applyFilter(this.projectSheetFilter);
        };
        ProjectSheetTableComponent.prototype.applyFilter = function (filter) {
            this.dataSource.filterSubject.next(filter);
        };
        ProjectSheetTableComponent.prototype.onAction = function (type, projectSheet) {
            if (type === void 0) { type = ""; }
            if (i0.isDevMode()) {
                console.debug(TAG$1, "onAction", projectSheet);
            }
            event.stopPropagation();
            this.fireAction({ type: type, projectSheet: projectSheet });
        };
        ProjectSheetTableComponent.prototype.fireAction = function (action) {
            this.action.emit(action);
        };
        return ProjectSheetTableComponent;
    }());
    /** @nocollapse */ ProjectSheetTableComponent.ɵfac = function ProjectSheetTableComponent_Factory(t) { return new (t || ProjectSheetTableComponent)(i0.ɵɵdirectiveInject(i0.forwardRef(function () { return i1.ProjectSheetService; })), i0.ɵɵdirectiveInject(i0.forwardRef(function () { return i2.ActivatedRoute; }))); };
    /** @nocollapse */ ProjectSheetTableComponent.ɵcmp = i0.ɵɵdefineComponent({ type: ProjectSheetTableComponent, selectors: [["chain-project-sheet-table"]], viewQuery: function ProjectSheetTableComponent_Query(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵstaticViewQuery(i3.MatPaginator, true);
                i0.ɵɵstaticViewQuery(i5.MatSort, true);
                i0.ɵɵstaticViewQuery(_c0$1, true);
            }
            if (rf & 2) {
                var _t = void 0;
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.filter = _t.first);
            }
        }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", projectSheetFilter: "projectSheetFilter" }, outputs: { action: "action" }, ngContentSelectors: _c3, decls: 37, vars: 8, consts: [["fxLayout", "row", "fxLayoutAlign", "space-between center", 1, ""], ["fxLayout", "row", "fxLayoutAlign", "space-between center", "fxFlex", ""], [1, "field-wrap"], [1, "field-box", "trans-icon"], ["type", "text"], ["projectsheetfilter", ""], ["type", "submit"], [1, ""], ["fxFlex", "30", 3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], [1, "table-layout-1"], ["matSort", "", "matSortActive", "reportDate", "matSortDirection", "desc", "matSortDisableClear", "", 3, "dataSource"], ["table", ""], ["matColumnDef", "reportDate"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "info.name"], ["matColumnDef", "status"], ["matColumnDef", "percentageOfCompletion"], ["matColumnDef", "budget.amount"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "action"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [1, "dot", 3, "ngClass"], [4, "ngIf"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-button", "", 3, "click"], ["color", "warn"], [3, "click"]], template: function ProjectSheetTableComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵprojectionDef();
                i0.ɵɵelementStart(0, "mat-toolbar", 0);
                i0.ɵɵelementStart(1, "div", 1);
                i0.ɵɵprojection(2);
                i0.ɵɵelementStart(3, "div", 2);
                i0.ɵɵelementStart(4, "div", 3);
                i0.ɵɵelement(5, "input", 4, 5);
                i0.ɵɵelementStart(7, "button", 6);
                i0.ɵɵelementStart(8, "i", 7);
                i0.ɵɵelementStart(9, "mat-icon");
                i0.ɵɵtext(10, " search ");
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelement(11, "mat-paginator", 8, 9);
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(13, "div", 10);
                i0.ɵɵelementStart(14, "mat-table", 11, 12);
                i0.ɵɵelementContainerStart(16, 13);
                i0.ɵɵtemplate(17, ProjectSheetTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 14);
                i0.ɵɵtemplate(18, ProjectSheetTableComponent_mat_cell_18_Template, 4, 3, "mat-cell", 15);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(19, 16);
                i0.ɵɵtemplate(20, ProjectSheetTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 14);
                i0.ɵɵtemplate(21, ProjectSheetTableComponent_mat_cell_21_Template, 3, 1, "mat-cell", 15);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(22, 17);
                i0.ɵɵtemplate(23, ProjectSheetTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 14);
                i0.ɵɵtemplate(24, ProjectSheetTableComponent_mat_cell_24_Template, 2, 5, "mat-cell", 15);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(25, 18);
                i0.ɵɵtemplate(26, ProjectSheetTableComponent_mat_header_cell_26_Template, 3, 3, "mat-header-cell", 14);
                i0.ɵɵtemplate(27, ProjectSheetTableComponent_mat_cell_27_Template, 2, 1, "mat-cell", 15);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(28, 19);
                i0.ɵɵtemplate(29, ProjectSheetTableComponent_mat_header_cell_29_Template, 3, 3, "mat-header-cell", 14);
                i0.ɵɵtemplate(30, ProjectSheetTableComponent_mat_cell_30_Template, 3, 1, "mat-cell", 15);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵtemplate(31, ProjectSheetTableComponent_ng_container_31_Template, 3, 1, "ng-container", 20);
                i0.ɵɵelementContainerStart(32, 21);
                i0.ɵɵtemplate(33, ProjectSheetTableComponent_mat_header_cell_33_Template, 1, 0, "mat-header-cell", 22);
                i0.ɵɵtemplate(34, ProjectSheetTableComponent_mat_cell_34_Template, 4, 0, "mat-cell", 15);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵtemplate(35, ProjectSheetTableComponent_mat_header_row_35_Template, 1, 0, "mat-header-row", 23);
                i0.ɵɵtemplate(36, ProjectSheetTableComponent_mat_row_36_Template, 1, 0, "mat-row", 24);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0.ɵɵadvance(11);
                i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(7, _c2));
                i0.ɵɵadvance(3);
                i0.ɵɵproperty("dataSource", ctx.dataSource);
                i0.ɵɵadvance(17);
                i0.ɵɵproperty("ngForOf", ctx.customColumns);
                i0.ɵɵadvance(4);
                i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
            }
        }, directives: [i3$1.DefaultLayoutDirective, i3$1.DefaultLayoutAlignDirective, i3$1.DefaultFlexDirective, i4$1.MatIcon, i3.MatPaginator, i4.MatTable, i5.MatSort, i4.MatColumnDef, i4.MatHeaderCellDef, i4.MatCellDef, i8.NgForOf, i4.MatHeaderRowDef, i4.MatRowDef, i4.MatHeaderCell, i5.MatSortHeader, i4.MatCell, i8.NgClass, i9.DefaultClassDirective, i8.NgIf, i7.CdkColumnDef, i7.CdkHeaderCellDef, i7.CdkCellDef, i11.MatButton, i4.MatHeaderRow, i4.MatRow], pipes: [i8$1.TranslatePipe, i8.DatePipe], styles: ["chain-project-sheet-table{width:100%}chain-project-sheet-table .mat-table{background:transparent;box-shadow:none}chain-project-sheet-table .mat-table .mat-row{cursor:pointer;min-height:64px;position:relative}.dot{border-radius:50%;display:inline-block;height:20px!important;margin-left:40px;width:20px!important}.dot-red{background-color:red}.dot-green{background-color:green}.dot-yellow{background-color:#ff0}"], encapsulation: 2 });
    /*@__PURE__*/ (function () {
        i0.ɵsetClassMetadata(ProjectSheetTableComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'chain-project-sheet-table',
                        templateUrl: './project-sheet-table.component.html',
                        styleUrls: ['./project-sheet-table.component.scss'],
                        encapsulation: i0.ViewEncapsulation.None
                    }]
            }], function () {
            return [{ type: i1.ProjectSheetService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.ProjectSheetService; })]
                        }] }, { type: i2.ActivatedRoute, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i2.ActivatedRoute; })]
                        }] }];
        }, { displayedColumns: [{
                    type: i0.Input
                }], customColumns: [{
                    type: i0.Input
                }], projectSheetFilter: [{
                    type: i0.Input
                }], action: [{
                    type: i0.Output
                }], paginator: [{
                    type: i0.ViewChild,
                    args: [i3.MatPaginator, { static: true }]
                }], sort: [{
                    type: i0.ViewChild,
                    args: [i5.MatSort, { static: true }]
                }], filter: [{
                    type: i0.ViewChild,
                    args: ['projectsheetfilter', { static: true }]
                }] });
    })();

    var RisksTableQueryStore = /** @class */ (function (_super) {
        __extends(RisksTableQueryStore, _super);
        function RisksTableQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        RisksTableQueryStore.prototype.queryTable = function () {
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.queryRisks(filter);
        };
        return RisksTableQueryStore;
    }(chainBaseAngularStore.QueryTableSource));

    function RisksTableComponent_mat_header_cell_8_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 19);
            i0.ɵɵtext(1, "Risk Id");
            i0.ɵɵelementEnd();
        }
    }
    function RisksTableComponent_mat_cell_9_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r19 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r19 == null ? null : row_r19.riskId);
        }
    }
    function RisksTableComponent_mat_header_cell_11_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 19);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.RISK.NAME"));
        }
    }
    function RisksTableComponent_mat_cell_12_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r20 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r20 == null ? null : row_r20.name);
        }
    }
    function RisksTableComponent_mat_header_cell_14_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 19);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.MITIGATION"));
        }
    }
    function RisksTableComponent_mat_cell_15_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r21 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r21 == null ? null : row_r21.mitigation);
        }
    }
    function RisksTableComponent_mat_header_cell_17_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 19);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.RISKS.SEVERITY"));
        }
    }
    function RisksTableComponent_mat_cell_18_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r22 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r22 == null ? null : row_r22.severity);
        }
    }
    function RisksTableComponent_mat_header_cell_20_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 19);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT_SHEET.PROBABILITY"));
        }
    }
    function RisksTableComponent_mat_cell_21_span_1_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "span");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r23 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate((row_r23 == null ? null : row_r23.probability) + "%");
        }
    }
    function RisksTableComponent_mat_cell_21_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtemplate(1, RisksTableComponent_mat_cell_21_span_1_Template, 2, 1, "span", 20);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r23 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", row_r23.probability);
        }
    }
    function RisksTableComponent_mat_header_cell_23_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 19);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "PROJECT.RISKS.STATUS"));
        }
    }
    function RisksTableComponent_mat_cell_24_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r26 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r26 == null ? null : row_r26.status);
        }
    }
    function RisksTableComponent_ng_container_25_mat_header_cell_1_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var column_r27 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(column_r27.header);
        }
    }
    function RisksTableComponent_ng_container_25_mat_cell_2_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r31 = ctx.$implicit;
            var column_r27 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(column_r27.cell(row_r31));
        }
    }
    function RisksTableComponent_ng_container_25_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementContainerStart(0, 21);
            i0.ɵɵtemplate(1, RisksTableComponent_ng_container_25_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 22);
            i0.ɵɵtemplate(2, RisksTableComponent_ng_container_25_mat_cell_2_Template, 2, 1, "mat-cell", 23);
            i0.ɵɵelementContainerEnd();
        }
        if (rf & 2) {
            var column_r27 = ctx.$implicit;
            i0.ɵɵproperty("cdkColumnDef", column_r27.columnDef);
        }
    }
    function RisksTableComponent_mat_header_cell_27_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelement(0, "mat-header-cell");
        }
    }
    function RisksTableComponent_mat_cell_28_Template(rf, ctx) {
        if (rf & 1) {
            var _r35_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "button", 24);
            i0.ɵɵlistener("click", function RisksTableComponent_mat_cell_28_Template_button_click_1_listener($event) { i0.ɵɵrestoreView(_r35_1); var row_r33 = ctx.$implicit; var ctx_r34 = i0.ɵɵnextContext(); ctx_r34.deleteRisk(row_r33.riskId); return $event.stopPropagation(); });
            i0.ɵɵelementStart(2, "mat-icon", 25);
            i0.ɵɵtext(3, " delete ");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
    }
    function RisksTableComponent_mat_header_row_29_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelement(0, "mat-header-row");
        }
    }
    function RisksTableComponent_mat_row_30_Template(rf, ctx) {
        if (rf & 1) {
            var _r38_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "mat-row", 26);
            i0.ɵɵlistener("click", function RisksTableComponent_mat_row_30_Template_mat_row_click_0_listener() { i0.ɵɵrestoreView(_r38_1); var row_r36 = ctx.$implicit; var ctx_r37 = i0.ɵɵnextContext(); return ctx_r37.onAction("edit", row_r36); });
            i0.ɵɵelementEnd();
        }
    }
    var _c0$2 = function () { return [5, 10, 25, 100]; };
    var _c1$1 = ["*"];
    var RisksTableComponent = /** @class */ (function () {
        function RisksTableComponent(_riskService) {
            this._riskService = _riskService;
            this.displayedColumns = ['name', 'mitigation', 'severity', 'probability', 'status'];
            this.customColumns = [];
            this.action = new i0.EventEmitter();
        }
        RisksTableComponent.prototype.ngOnInit = function () {
            var _a;
            if (this.customColumns && this.customColumns.length > 0) {
                var abc = this.customColumns.map(function (c) { return c.columnDef; });
                (_a = this.displayedColumns).push.apply(_a, __spread(abc));
                this.displayedColumns.push("actions");
            }
            else {
                this.displayedColumns.push("actions");
            }
            var filter = {};
            //TODO change this when RisksFilter is exposd GK
            filter['projectId'] = this.projectId;
            if (!this.dataSource) {
                this.dataSource = new RisksTableQueryStore(this._riskService, this.paginator, this.sort, filter);
            }
        };
        RisksTableComponent.prototype.onAction = function (type, payload) {
            this.action.emit({ type: type, value: payload });
        };
        RisksTableComponent.prototype.deleteRisk = function (event) {
            this.onAction('delete', { riskId: event });
        };
        return RisksTableComponent;
    }());
    /** @nocollapse */ RisksTableComponent.ɵfac = function RisksTableComponent_Factory(t) { return new (t || RisksTableComponent)(i0.ɵɵdirectiveInject(i0.forwardRef(function () { return i1.RiskService; }))); };
    /** @nocollapse */ RisksTableComponent.ɵcmp = i0.ɵɵdefineComponent({ type: RisksTableComponent, selectors: [["chain-app-risks-table"]], viewQuery: function RisksTableComponent_Query(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵstaticViewQuery(i3.MatPaginator, true);
                i0.ɵɵstaticViewQuery(i5.MatSort, true);
            }
            if (rf & 2) {
                var _t = void 0;
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
            }
        }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", projectId: "projectId", dataSource: "dataSource" }, outputs: { action: "action" }, ngContentSelectors: _c1$1, decls: 31, vars: 8, consts: [[1, "table-layout-1"], ["fxLayoutAlign", "space-between center", 1, ""], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "riskId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "name"], ["matColumnDef", "mitigation"], ["matColumnDef", "severity"], ["matColumnDef", "probability"], ["matColumnDef", "status"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "actions"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [4, "ngIf"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-button", "", 3, "click"], ["color", "warn", 1, ""], [3, "click"]], template: function RisksTableComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵprojectionDef();
                i0.ɵɵelementStart(0, "div", 0);
                i0.ɵɵelementStart(1, "mat-toolbar", 1);
                i0.ɵɵprojection(2);
                i0.ɵɵelement(3, "mat-paginator", 2, 3);
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(5, "mat-table", 4, 5);
                i0.ɵɵelementContainerStart(7, 6);
                i0.ɵɵtemplate(8, RisksTableComponent_mat_header_cell_8_Template, 2, 0, "mat-header-cell", 7);
                i0.ɵɵtemplate(9, RisksTableComponent_mat_cell_9_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(10, 9);
                i0.ɵɵtemplate(11, RisksTableComponent_mat_header_cell_11_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(12, RisksTableComponent_mat_cell_12_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(13, 10);
                i0.ɵɵtemplate(14, RisksTableComponent_mat_header_cell_14_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(15, RisksTableComponent_mat_cell_15_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(16, 11);
                i0.ɵɵtemplate(17, RisksTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(18, RisksTableComponent_mat_cell_18_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(19, 12);
                i0.ɵɵtemplate(20, RisksTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(21, RisksTableComponent_mat_cell_21_Template, 2, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(22, 13);
                i0.ɵɵtemplate(23, RisksTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(24, RisksTableComponent_mat_cell_24_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵtemplate(25, RisksTableComponent_ng_container_25_Template, 3, 1, "ng-container", 14);
                i0.ɵɵelementContainerStart(26, 15);
                i0.ɵɵtemplate(27, RisksTableComponent_mat_header_cell_27_Template, 1, 0, "mat-header-cell", 16);
                i0.ɵɵtemplate(28, RisksTableComponent_mat_cell_28_Template, 4, 0, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵtemplate(29, RisksTableComponent_mat_header_row_29_Template, 1, 0, "mat-header-row", 17);
                i0.ɵɵtemplate(30, RisksTableComponent_mat_row_30_Template, 1, 0, "mat-row", 18);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0.ɵɵadvance(3);
                i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(7, _c0$2));
                i0.ɵɵadvance(2);
                i0.ɵɵproperty("dataSource", ctx.dataSource);
                i0.ɵɵadvance(20);
                i0.ɵɵproperty("ngForOf", ctx.customColumns);
                i0.ɵɵadvance(4);
                i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
            }
        }, directives: [i3$1.DefaultLayoutAlignDirective, i3.MatPaginator, i4.MatTable, i5.MatSort, i4.MatColumnDef, i4.MatHeaderCellDef, i4.MatCellDef, i8.NgForOf, i4.MatHeaderRowDef, i4.MatRowDef, i4.MatHeaderCell, i5.MatSortHeader, i4.MatCell, i8.NgIf, i7.CdkColumnDef, i7.CdkHeaderCellDef, i7.CdkCellDef, i11.MatButton, i4$1.MatIcon, i4.MatHeaderRow, i4.MatRow], pipes: [i8$1.TranslatePipe], styles: [""] });
    /*@__PURE__*/ (function () {
        i0.ɵsetClassMetadata(RisksTableComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'chain-app-risks-table',
                        templateUrl: './risks-table.component.html',
                        styleUrls: ['./risks-table.component.scss']
                    }]
            }], function () {
            return [{ type: i1.RiskService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.RiskService; })]
                        }] }];
        }, { displayedColumns: [{
                    type: i0.Input
                }], customColumns: [{
                    type: i0.Input
                }], projectId: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], action: [{
                    type: i0.Output
                }], paginator: [{
                    type: i0.ViewChild,
                    args: [i3.MatPaginator, { static: true }]
                }], sort: [{
                    type: i0.ViewChild,
                    args: [i5.MatSort, { static: true }]
                }] });
    })();

    function AddressComponent_mat_option_33_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-option", 15);
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var country_r1 = ctx.$implicit;
            i0.ɵɵproperty("value", country_r1.iso);
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate2(" ", country_r1.name, " (", country_r1.iso, ") ");
        }
    }
    var AddressComponent = /** @class */ (function () {
        function AddressComponent() {
            this.countries = [];
        }
        AddressComponent.prototype.ngOnInit = function () {
        };
        return AddressComponent;
    }());
    /** @nocollapse */ AddressComponent.ɵfac = function AddressComponent_Factory(t) { return new (t || AddressComponent)(); };
    /** @nocollapse */ AddressComponent.ɵcmp = i0.ɵɵdefineComponent({ type: AddressComponent, selectors: [["chain-app-address"]], inputs: { formGroup: "formGroup", countries: "countries" }, decls: 34, vars: 17, consts: [[3, "formGroup"], [1, "form-row"], [1, "col65"], ["appearance", "outline", "floatLabel", "always", 1, "field-wrap"], ["matInput", "", "formControlName", "street", "name", "firstName"], [1, "col33"], ["matInput", "", "formControlName", "houseNumber"], [1, "col20"], ["matInput", "", "formControlName", "zipCode"], [1, "col50"], ["matInput", "", "formControlName", "city", "name", "firstName"], [1, "col30"], [1, "field-wrap"], ["ngDefaultControl", "", "formControlName", "countryCode", "name", "countryCode"], [3, "value", 4, "ngFor", "ngForOf"], [3, "value"]], template: function AddressComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵelementStart(0, "form", 0);
                i0.ɵɵelementStart(1, "div", 1);
                i0.ɵɵelementStart(2, "div", 2);
                i0.ɵɵelementStart(3, "div", 3);
                i0.ɵɵelementStart(4, "mat-label");
                i0.ɵɵtext(5);
                i0.ɵɵpipe(6, "translate");
                i0.ɵɵelementEnd();
                i0.ɵɵelement(7, "input", 4);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(8, "div", 5);
                i0.ɵɵelementStart(9, "div", 3);
                i0.ɵɵelementStart(10, "mat-label");
                i0.ɵɵtext(11);
                i0.ɵɵpipe(12, "translate");
                i0.ɵɵelementEnd();
                i0.ɵɵelement(13, "input", 6);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(14, "div", 1);
                i0.ɵɵelementStart(15, "div", 7);
                i0.ɵɵelementStart(16, "div", 3);
                i0.ɵɵelementStart(17, "mat-label");
                i0.ɵɵtext(18);
                i0.ɵɵpipe(19, "translate");
                i0.ɵɵelementEnd();
                i0.ɵɵelement(20, "input", 8);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(21, "div", 9);
                i0.ɵɵelementStart(22, "div", 3);
                i0.ɵɵelementStart(23, "mat-label");
                i0.ɵɵtext(24);
                i0.ɵɵpipe(25, "translate");
                i0.ɵɵelementEnd();
                i0.ɵɵelement(26, "input", 10);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(27, "div", 11);
                i0.ɵɵelementStart(28, "div", 12);
                i0.ɵɵelementStart(29, "mat-label");
                i0.ɵɵtext(30);
                i0.ɵɵpipe(31, "translate");
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(32, "mat-select", 13);
                i0.ɵɵtemplate(33, AddressComponent_mat_option_33_Template, 2, 3, "mat-option", 14);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0.ɵɵproperty("formGroup", ctx.formGroup);
                i0.ɵɵadvance(5);
                i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(6, 7, "ADDRESS.STREET"), " ");
                i0.ɵɵadvance(6);
                i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(12, 9, "ADDRESS.STREET_NUMBER"), " ");
                i0.ɵɵadvance(7);
                i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(19, 11, "ADDRESS.POST_CODE"), " ");
                i0.ɵɵadvance(6);
                i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(25, 13, "ADDRESS.CITY"), " ");
                i0.ɵɵadvance(6);
                i0.ɵɵtextInterpolate1("", i0.ɵɵpipeBind1(31, 15, "ADDRESS.COUNTRY"), " ");
                i0.ɵɵadvance(3);
                i0.ɵɵproperty("ngForOf", ctx.countries);
            }
        }, directives: [i1$1.ɵangular_packages_forms_forms_y, i1$1.NgControlStatusGroup, i1$1.FormGroupDirective, i2$1.MatLabel, i1$1.DefaultValueAccessor, i1$1.NgControlStatus, i1$1.FormControlName, i3$2.MatSelect, i8.NgForOf, i5$2.MatOption], pipes: [i8$1.TranslatePipe], styles: [""], encapsulation: 2 });
    /*@__PURE__*/ (function () {
        i0.ɵsetClassMetadata(AddressComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'chain-app-address',
                        templateUrl: './address.component.html',
                        styleUrls: ['./address.component.scss'],
                        encapsulation: i0.ViewEncapsulation.None
                    }]
            }], function () { return []; }, { formGroup: [{
                    type: i0.Input
                }], countries: [{
                    type: i0.Input
                }] });
    })();

    (function (AddressType) {
        AddressType["INVOICE"] = "INVOICE";
        AddressType["HOME"] = "HOME";
    })(exports.AddressType || (exports.AddressType = {}));
    var addressTypes = [];
    for (var n in exports.AddressType) {
        addressTypes.push(exports.AddressType[n]);
    }

    var AttachmentTableQueryStore = /** @class */ (function (_super) {
        __extends(AttachmentTableQueryStore, _super);
        function AttachmentTableQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        AttachmentTableQueryStore.prototype.queryTable = function () {
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.query(filter);
        };
        return AttachmentTableQueryStore;
    }(chainBaseAngularStore.QueryTableSource));

    function AttachmentTableComponent_mat_header_cell_8_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 20);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "ATTACHMENT.ID"));
        }
    }
    function AttachmentTableComponent_mat_cell_9_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r21 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r21 == null ? null : row_r21.attachmentId);
        }
    }
    function AttachmentTableComponent_mat_header_cell_11_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 20);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "ATTACHMENT.CATEGORY"));
        }
    }
    function AttachmentTableComponent_mat_cell_12_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r22 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r22 == null ? null : row_r22.category);
        }
    }
    function AttachmentTableComponent_mat_header_cell_14_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 20);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "ATTACHMENT.NAME"));
        }
    }
    function AttachmentTableComponent_mat_cell_15_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r23 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r23.file == null ? null : row_r23.file.fileName);
        }
    }
    function AttachmentTableComponent_mat_header_cell_17_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 20);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "ATTACHMENT.FILE_SIZE"));
        }
    }
    function AttachmentTableComponent_mat_cell_18_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span");
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r24 = ctx.$implicit;
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate(row_r24.file == null ? null : row_r24.file.fileSize);
        }
    }
    function AttachmentTableComponent_mat_header_cell_20_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 20);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "FEP.STATUS"));
        }
    }
    function AttachmentTableComponent_mat_cell_21_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelementStart(1, "span", 21);
            i0.ɵɵtext(2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r25 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matTooltip", row_r25.fepStatus.userIds);
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(row_r25.fepStatus == null ? null : row_r25.fepStatus.status);
        }
    }
    function AttachmentTableComponent_mat_header_cell_23_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 20);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "COMMON.CREATED_DATE"));
        }
    }
    function AttachmentTableComponent_mat_cell_24_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelement(1, "base-date", 22);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r26 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("data", row_r26.created == null ? null : row_r26.created.date)("matTooltip", row_r26.created == null ? null : row_r26.created.user);
        }
    }
    function AttachmentTableComponent_mat_header_cell_26_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell", 20);
            i0.ɵɵtext(1);
            i0.ɵɵpipe(2, "translate");
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(i0.ɵɵpipeBind1(2, 1, "COMMON.CHANGE_DATE"));
        }
    }
    function AttachmentTableComponent_mat_cell_27_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵelement(1, "base-date", 22);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r27 = ctx.$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("data", row_r27.change == null ? null : row_r27.change.date)("matTooltip", row_r27.change == null ? null : row_r27.change.user);
        }
    }
    function AttachmentTableComponent_ng_container_28_mat_header_cell_1_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-header-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var column_r28 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(column_r28.header);
        }
    }
    function AttachmentTableComponent_ng_container_28_mat_cell_2_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r32 = ctx.$implicit;
            var column_r28 = i0.ɵɵnextContext().$implicit;
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate(column_r28.cell(row_r32));
        }
    }
    function AttachmentTableComponent_ng_container_28_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementContainerStart(0, 23);
            i0.ɵɵtemplate(1, AttachmentTableComponent_ng_container_28_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 24);
            i0.ɵɵtemplate(2, AttachmentTableComponent_ng_container_28_mat_cell_2_Template, 2, 1, "mat-cell", 25);
            i0.ɵɵelementContainerEnd();
        }
        if (rf & 2) {
            var column_r28 = ctx.$implicit;
            i0.ɵɵproperty("cdkColumnDef", column_r28.columnDef);
        }
    }
    function AttachmentTableComponent_mat_header_cell_30_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelement(0, "mat-header-cell");
        }
    }
    function AttachmentTableComponent_mat_cell_31_button_1_Template(rf, ctx) {
        if (rf & 1) {
            var _r41_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "button", 30);
            i0.ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_1_Template_button_click_0_listener($event) { i0.ɵɵrestoreView(_r41_1); var row_r34 = i0.ɵɵnextContext().$implicit; var ctx_r39 = i0.ɵɵnextContext(); ctx_r39.onAction("delete", row_r34); return $event.stopPropagation(); });
            i0.ɵɵelementStart(1, "mat-icon", 31);
            i0.ɵɵtext(2, "delete");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r34 = i0.ɵɵnextContext().$implicit;
            var ctx_r35 = i0.ɵɵnextContext();
            i0.ɵɵpropertyInterpolate("disabled", ctx_r35.isDisabled("delete", row_r34));
        }
    }
    function AttachmentTableComponent_mat_cell_31_button_2_Template(rf, ctx) {
        if (rf & 1) {
            var _r45_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "button", 32);
            i0.ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_2_Template_button_click_0_listener($event) { i0.ɵɵrestoreView(_r45_1); var row_r34 = i0.ɵɵnextContext().$implicit; var ctx_r43 = i0.ɵɵnextContext(); ctx_r43.onAction("request", row_r34); return $event.stopPropagation(); });
            i0.ɵɵelementStart(1, "mat-icon", 33);
            i0.ɵɵtext(2, "send");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
    }
    function AttachmentTableComponent_mat_cell_31_button_3_Template(rf, ctx) {
        if (rf & 1) {
            var _r48_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "button", 34);
            i0.ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_3_Template_button_click_0_listener($event) { i0.ɵɵrestoreView(_r48_1); var row_r34 = i0.ɵɵnextContext().$implicit; var ctx_r46 = i0.ɵɵnextContext(); ctx_r46.onAction("confirm", row_r34); return $event.stopPropagation(); });
            i0.ɵɵelementStart(1, "mat-icon", 33);
            i0.ɵɵtext(2, "check");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r34 = i0.ɵɵnextContext().$implicit;
            var ctx_r37 = i0.ɵɵnextContext();
            i0.ɵɵproperty("disabled", ctx_r37.isDisabled("confirm", row_r34));
        }
    }
    function AttachmentTableComponent_mat_cell_31_button_4_Template(rf, ctx) {
        if (rf & 1) {
            var _r52_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "button", 35);
            i0.ɵɵlistener("click", function AttachmentTableComponent_mat_cell_31_button_4_Template_button_click_0_listener($event) { i0.ɵɵrestoreView(_r52_1); var row_r34 = i0.ɵɵnextContext().$implicit; var ctx_r50 = i0.ɵɵnextContext(); ctx_r50.onAction("reject", row_r34); return $event.stopPropagation(); });
            i0.ɵɵelementStart(1, "mat-icon", 33);
            i0.ɵɵtext(2, "backspace");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r34 = i0.ɵɵnextContext().$implicit;
            var ctx_r38 = i0.ɵɵnextContext();
            i0.ɵɵproperty("disabled", ctx_r38.isDisabled("reject", row_r34));
        }
    }
    function AttachmentTableComponent_mat_cell_31_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-cell");
            i0.ɵɵtemplate(1, AttachmentTableComponent_mat_cell_31_button_1_Template, 3, 1, "button", 26);
            i0.ɵɵtemplate(2, AttachmentTableComponent_mat_cell_31_button_2_Template, 3, 0, "button", 27);
            i0.ɵɵtemplate(3, AttachmentTableComponent_mat_cell_31_button_3_Template, 3, 1, "button", 28);
            i0.ɵɵtemplate(4, AttachmentTableComponent_mat_cell_31_button_4_Template, 3, 1, "button", 29);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            var row_r34 = ctx.$implicit;
            var ctx_r18 = i0.ɵɵnextContext();
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx_r18.showAction("delete", row_r34));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx_r18.showAction("request", row_r34));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx_r18.showAction("confirm", row_r34));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx_r18.showAction("reject", row_r34));
        }
    }
    function AttachmentTableComponent_mat_header_row_32_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelement(0, "mat-header-row");
        }
    }
    function AttachmentTableComponent_mat_row_33_Template(rf, ctx) {
        if (rf & 1) {
            var _r56_1 = i0.ɵɵgetCurrentView();
            i0.ɵɵelementStart(0, "mat-row", 36);
            i0.ɵɵlistener("click", function AttachmentTableComponent_mat_row_33_Template_mat_row_click_0_listener() { i0.ɵɵrestoreView(_r56_1); var row_r54 = ctx.$implicit; var ctx_r55 = i0.ɵɵnextContext(); return ctx_r55.onAction("select", row_r54); });
            i0.ɵɵelementEnd();
        }
    }
    var _c0$3 = function () { return [5, 10, 25, 100]; };
    var _c1$2 = ["*"];
    var TAG$2 = 'AttachmentTableComponent';
    var AttachmentTableComponent = /** @class */ (function () {
        function AttachmentTableComponent(_service) {
            this._service = _service;
            this.displayedColumns = [
                'file.fileId', 'file.fileName', 'file.fileSize',
                'category', 'change.date', 'fepStatus.status'
            ];
            this.customColumns = [];
            this.showFep = true;
            this.filter = {};
            this.action = new i0.EventEmitter();
            //protected _auth : AuthService
        }
        AttachmentTableComponent.prototype.ngOnInit = function () {
            var _a;
            if (this.customColumns && this.customColumns.length > 0) {
                var abc = this.customColumns.map(function (c) { return c.columnDef; });
                (_a = this.displayedColumns).push.apply(_a, __spread(abc));
                this.displayedColumns.push("actions");
            }
            else {
                this.displayedColumns.push("actions");
            }
            var filter = this.filter;
            if (!this.dataSource) {
                this.dataSource = new AttachmentTableQueryStore(this._service, this.paginator, this.sort, filter);
            }
        };
        AttachmentTableComponent.prototype.reload = function () {
            this.dataSource.reload();
        };
        AttachmentTableComponent.prototype.onAction = function (type, payload) {
            this.action.emit({ type: type, value: payload });
        };
        AttachmentTableComponent.prototype.isDisabled = function (action, row) {
            if ('delete' == action && row.fepStatus.status && i1.Fep.CONFIRMED == row.fepStatus.status) {
                // @toDo * [ww] check admin
                //console.log(TAG, "isDisabled", this._auth.getUserRoles())
                return false; //!this._auth.isAdmin(); // admin can always delete
            }
            else if ('confirm' == action && row.fepStatus.status && i1.Fep.WAIT_FOR_CONFIRM == row.fepStatus.status) {
                // check if user not already confirmed
                return false; //row.fepStatus.userIds && row.fepStatus.userIds.indexOf(this._auth.getUserName()) !== -1;
            }
            return false;
        };
        AttachmentTableComponent.prototype.showAction = function (action, row) {
            if (this.displayedActions && this.displayedActions.indexOf(action) == -1)
                return false;
            // @toDo * [ww] check user roles
            if ('delete' == action)
                return true;
            if (['confirm', 'request', 'reject'].indexOf(action) !== -1 && this.showFep && row.fepStatus) {
                var fs = row.fepStatus.status;
                if ('request' == action)
                    return false; // never show request for now
                //return Fep.NEW == fs || Fep.REJECTED == fs;
                else if ('confirm' == action)
                    return i1.Fep.WAIT_FOR_CONFIRM == fs; //&& this._auth.hasAnyRole([Yukawa_LeanRealm.ROLE_INVOICE_FEP_CONFIRM, Yukawa_LeanRealm.ROLE_INVOICE_FEP_CONFIRM_PARTIAL]);
                else if ('reject' == action)
                    return i1.Fep.WAIT_FOR_CONFIRM == fs; //&& this._auth.hasRole(Yukawa_LeanRealm.ROLE_INVOICE_FEP_REJECT);
            }
            return true;
        };
        AttachmentTableComponent.prototype.showFepButton = function (action, row) {
            if (!this.showFep || !row.fepStatus)
                return false;
            if ('request' == action)
                return i1.Fep.NEW == row.fepStatus.status || i1.Fep.REJECTED == row.fepStatus.status;
            else if ('confirm' == action || 'reject' == action)
                return i1.Fep.WAIT_FOR_CONFIRM == row.fepStatus.status;
            return false;
        };
        return AttachmentTableComponent;
    }());
    /** @nocollapse */ AttachmentTableComponent.ɵfac = function AttachmentTableComponent_Factory(t) { return new (t || AttachmentTableComponent)(i0.ɵɵdirectiveInject(i0.forwardRef(function () { return i1.AttachmentService; }))); };
    /** @nocollapse */ AttachmentTableComponent.ɵcmp = i0.ɵɵdefineComponent({ type: AttachmentTableComponent, selectors: [["tracker-attachment-table"]], viewQuery: function AttachmentTableComponent_Query(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵstaticViewQuery(i3.MatPaginator, true);
                i0.ɵɵstaticViewQuery(i5.MatSort, true);
            }
            if (rf & 2) {
                var _t = void 0;
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.paginator = _t.first);
                i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
            }
        }, inputs: { displayedColumns: "displayedColumns", customColumns: "customColumns", displayedActions: "displayedActions", showFep: "showFep", filter: "filter", dataSource: "dataSource" }, outputs: { action: "action" }, ngContentSelectors: _c1$2, decls: 34, vars: 8, consts: [[1, "table-layout-1"], ["fxLayoutAlign", "space-between center", 1, ""], [3, "pageIndex", "pageSize", "pageSizeOptions"], ["paginator", ""], ["matSort", "", "matSortActive", "change.date", "matSortDirection", "desc", "matSortDisableClear", "", 1, "table-hover-1", 3, "dataSource"], ["table", ""], ["matColumnDef", "file.fileId"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["matColumnDef", "category"], ["matColumnDef", "file.fileName"], ["matColumnDef", "file.fileSize"], ["matColumnDef", "fepStatus.status"], ["matColumnDef", "created.date"], ["matColumnDef", "change.date"], [3, "cdkColumnDef", 4, "ngFor", "ngForOf"], ["matColumnDef", "actions"], [4, "matHeaderCellDef"], [4, "matHeaderRowDef"], [3, "click", 4, "matRowDef", "matRowDefColumns"], ["mat-sort-header", ""], [3, "matTooltip"], ["format", "date", "formatTip", "false", 3, "data", "matTooltip"], [3, "cdkColumnDef"], [4, "cdkHeaderCellDef"], [4, "cdkCellDef"], ["mat-raised-button", "", "matTooltip", "Delete", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Request confirmation", 3, "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Confirm", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Reject", 3, "disabled", "click", 4, "ngIf"], ["mat-raised-button", "", "matTooltip", "Delete", 3, "disabled", "click"], ["color", "warn"], ["mat-raised-button", "", "matTooltip", "Request confirmation", 3, "click"], ["color", "accent"], ["mat-raised-button", "", "matTooltip", "Confirm", 3, "disabled", "click"], ["mat-raised-button", "", "matTooltip", "Reject", 3, "disabled", "click"], [3, "click"]], template: function AttachmentTableComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0.ɵɵprojectionDef();
                i0.ɵɵelementStart(0, "div", 0);
                i0.ɵɵelementStart(1, "mat-toolbar", 1);
                i0.ɵɵprojection(2);
                i0.ɵɵelement(3, "mat-paginator", 2, 3);
                i0.ɵɵelementEnd();
                i0.ɵɵelementStart(5, "mat-table", 4, 5);
                i0.ɵɵelementContainerStart(7, 6);
                i0.ɵɵtemplate(8, AttachmentTableComponent_mat_header_cell_8_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(9, AttachmentTableComponent_mat_cell_9_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(10, 9);
                i0.ɵɵtemplate(11, AttachmentTableComponent_mat_header_cell_11_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(12, AttachmentTableComponent_mat_cell_12_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(13, 10);
                i0.ɵɵtemplate(14, AttachmentTableComponent_mat_header_cell_14_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(15, AttachmentTableComponent_mat_cell_15_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(16, 11);
                i0.ɵɵtemplate(17, AttachmentTableComponent_mat_header_cell_17_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(18, AttachmentTableComponent_mat_cell_18_Template, 3, 1, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(19, 12);
                i0.ɵɵtemplate(20, AttachmentTableComponent_mat_header_cell_20_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(21, AttachmentTableComponent_mat_cell_21_Template, 3, 2, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(22, 13);
                i0.ɵɵtemplate(23, AttachmentTableComponent_mat_header_cell_23_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(24, AttachmentTableComponent_mat_cell_24_Template, 2, 2, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵelementContainerStart(25, 14);
                i0.ɵɵtemplate(26, AttachmentTableComponent_mat_header_cell_26_Template, 3, 3, "mat-header-cell", 7);
                i0.ɵɵtemplate(27, AttachmentTableComponent_mat_cell_27_Template, 2, 2, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵtemplate(28, AttachmentTableComponent_ng_container_28_Template, 3, 1, "ng-container", 15);
                i0.ɵɵelementContainerStart(29, 16);
                i0.ɵɵtemplate(30, AttachmentTableComponent_mat_header_cell_30_Template, 1, 0, "mat-header-cell", 17);
                i0.ɵɵtemplate(31, AttachmentTableComponent_mat_cell_31_Template, 5, 4, "mat-cell", 8);
                i0.ɵɵelementContainerEnd();
                i0.ɵɵtemplate(32, AttachmentTableComponent_mat_header_row_32_Template, 1, 0, "mat-header-row", 18);
                i0.ɵɵtemplate(33, AttachmentTableComponent_mat_row_33_Template, 1, 0, "mat-row", 19);
                i0.ɵɵelementEnd();
                i0.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0.ɵɵadvance(3);
                i0.ɵɵproperty("pageIndex", 0)("pageSize", 10)("pageSizeOptions", i0.ɵɵpureFunction0(7, _c0$3));
                i0.ɵɵadvance(2);
                i0.ɵɵproperty("dataSource", ctx.dataSource);
                i0.ɵɵadvance(23);
                i0.ɵɵproperty("ngForOf", ctx.customColumns);
                i0.ɵɵadvance(4);
                i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
                i0.ɵɵadvance(1);
                i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
            }
        }, directives: [i3$1.DefaultLayoutAlignDirective, i3.MatPaginator, i4.MatTable, i5.MatSort, i4.MatColumnDef, i4.MatHeaderCellDef, i4.MatCellDef, i8.NgForOf, i4.MatHeaderRowDef, i4.MatRowDef, i4.MatHeaderCell, i5.MatSortHeader, i4.MatCell, i5$1.MatTooltip, i7.CdkColumnDef, i7.CdkHeaderCellDef, i7.CdkCellDef, i8.NgIf, i11.MatButton, i4$1.MatIcon, i4.MatHeaderRow, i4.MatRow], pipes: [i8$1.TranslatePipe], encapsulation: 2 });
    /*@__PURE__*/ (function () {
        i0.ɵsetClassMetadata(AttachmentTableComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'tracker-attachment-table',
                        templateUrl: './attachment-table.component.html',
                        styleUrls: [ /*'./attachment-table.component.scss'*/]
                    }]
            }], function () {
            return [{ type: i1.AttachmentService, decorators: [{
                            type: i0.Inject,
                            args: [i0.forwardRef(function () { return i1.AttachmentService; })]
                        }] }];
        }, { displayedColumns: [{
                    type: i0.Input
                }], customColumns: [{
                    type: i0.Input
                }], displayedActions: [{
                    type: i0.Input
                }], showFep: [{
                    type: i0.Input
                }], filter: [{
                    type: i0.Input
                }], dataSource: [{
                    type: i0.Input
                }], action: [{
                    type: i0.Output
                }], paginator: [{
                    type: i0.ViewChild,
                    args: [i3.MatPaginator, { static: true }]
                }], sort: [{
                    type: i0.ViewChild,
                    args: [i5.MatSort, { static: true }]
                }] });
    })();

    // modules
    // services
    var TrackerCompModule = /** @class */ (function () {
        function TrackerCompModule() {
        }
        return TrackerCompModule;
    }());
    /** @nocollapse */ TrackerCompModule.ɵmod = i0.ɵɵdefineNgModule({ type: TrackerCompModule });
    /** @nocollapse */ TrackerCompModule.ɵinj = i0.ɵɵdefineInjector({ factory: function TrackerCompModule_Factory(t) { return new (t || TrackerCompModule)(); }, providers: [], imports: [[
                i8.CommonModule,
                i1$1.FormsModule,
                i1$1.ReactiveFormsModule,
                i11.MatButtonModule,
                i4$1.MatIconModule,
                i5$2.MatRippleModule,
                slideToggle.MatSlideToggleModule,
                i4.MatTableModule,
                i5.MatSortModule,
                i5$1.MatTooltipModule,
                flexLayout.FlexLayoutModule,
                menu.MatMenuModule,
                checkbox.MatCheckboxModule,
                http.HttpClientModule,
                i3.MatPaginatorModule,
                i3$2.MatSelectModule,
                i7.CdkTableModule,
                i8$1.TranslateModule.forChild()
            ]] });
    (function () {
        (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(TrackerCompModule, { declarations: [ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent], imports: [i8.CommonModule,
                i1$1.FormsModule,
                i1$1.ReactiveFormsModule,
                i11.MatButtonModule,
                i4$1.MatIconModule,
                i5$2.MatRippleModule,
                slideToggle.MatSlideToggleModule,
                i4.MatTableModule,
                i5.MatSortModule,
                i5$1.MatTooltipModule,
                flexLayout.FlexLayoutModule,
                menu.MatMenuModule,
                checkbox.MatCheckboxModule,
                http.HttpClientModule,
                i3.MatPaginatorModule,
                i3$2.MatSelectModule,
                i7.CdkTableModule, i8$1.TranslateModule], exports: [ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent] });
    })();
    /*@__PURE__*/ (function () {
        i0.ɵsetClassMetadata(TrackerCompModule, [{
                type: i0.NgModule,
                args: [{
                        imports: [
                            i8.CommonModule,
                            i1$1.FormsModule,
                            i1$1.ReactiveFormsModule,
                            i11.MatButtonModule,
                            i4$1.MatIconModule,
                            i5$2.MatRippleModule,
                            slideToggle.MatSlideToggleModule,
                            i4.MatTableModule,
                            i5.MatSortModule,
                            i5$1.MatTooltipModule,
                            flexLayout.FlexLayoutModule,
                            menu.MatMenuModule,
                            checkbox.MatCheckboxModule,
                            http.HttpClientModule,
                            i3.MatPaginatorModule,
                            i3$2.MatSelectModule,
                            i7.CdkTableModule,
                            i8$1.TranslateModule.forChild()
                        ],
                        declarations: [
                            ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent
                        ],
                        exports: [
                            ProjectTableComponent, AddressComponent, AttachmentTableComponent, ProjectSheetTableComponent, RisksTableComponent
                        ],
                        providers: [],
                        entryComponents: [],
                        schemas: [i0.CUSTOM_ELEMENTS_SCHEMA]
                    }]
            }], null, null);
    })();

    /*
     * Public API
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AddressComponent = AddressComponent;
    exports.AttachmentTableComponent = AttachmentTableComponent;
    exports.AttachmentTableQueryStore = AttachmentTableQueryStore;
    exports.ProjectQueryStore = ProjectQueryStore;
    exports.ProjectSheetQueryStore = ProjectSheetQueryStore;
    exports.ProjectSheetTableComponent = ProjectSheetTableComponent;
    exports.ProjectTableComponent = ProjectTableComponent;
    exports.RisksTableComponent = RisksTableComponent;
    exports.RisksTableQueryStore = RisksTableQueryStore;
    exports.TrackerCompModule = TrackerCompModule;
    exports.addressTypes = addressTypes;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-tracker-angular-comp.umd.js.map
